/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * ᥤؿŪԽΤδؿ
 * ƼؿƤӽФδؿ              
 */

/*
 * Cmemo : Text Editor
 * cmemo.c - main source file
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <signal.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include "cme_def.h"
#include "cmemo.h"
#include "files.h"
#include "linenum.h"
#include "coloron.h"
#include "document.h"
#include "undo.h"
#include "warning.h"
#include "search.h"
#include "ini_file.h"
#include "interface.h"
#include "kanji_conv.h"
#include "cme_misc.h"
#include "global_search.h"
#include "initial.h"
#include "jump.h"
#include "auto_indent.h"
#include "keys.h"

GtkWidget *cm_window;
GtkWidget *cm_menu_bar;
GtkWidget *cm_gsearch_wnd;
GtkWidget *cm_focused_editable;
GdkFont *cm_keyword_font; /* ѤΥե */
GdkFont *cm_normal_font;  /* ̤ʸѤΥե */
int cm_end_flag;
filestruct *current_document; /* ե빽¤ */
struct search_struct cm_search;
struct jump_struct cm_jump;

static int shared_memory_id; /* ͭID */

/* åȤΥǥեȤΥ顼 */
static char rcstring[] = {
  "style \"default\"
  {
    bg[NORMAL] = { 0.8, 0.8, 0.8 }
  }
  widget_class \"*\" style \"default\""
};

/* ƥΰΥǥեȤΥե */
static char rc_def_font[] = {
  "style \"text\"
  {
    fontset = \"%s\"
  }
  widget_class \"*GtkText\" style \"text\""
};


/********************************
   ᥤ󥦥ɥλν
 ********************************/
int main_win_destroy(GtkWidget *widget, gpointer data)
{
  int i;

  /* ɥx򥯥åŤ˸ƤФ餷... */
  if (cm_end_flag == 1) {
    return(0);
  }

  /* destroy_current_document()ǳΰ˥ʤ褦 */
  /* ˤ뤿ˡcm_end_flagΥåϾǹԤ褦˽롣*/
  /* (Thanks to MATSUMURA tomohiro) (2001.11.9)                   */
  if (current_document->modified == TRUE) {
    i = warning(" Modified buffers exist.\nDo you exit anyway?");
    if (i == 1) {
      return(1);
    }
  }

  cm_end_flag = 1;

  /* եȤä鳫 */
  if ((int)cm_keyword_font != (int)NULL) {
    gdk_font_unref(cm_keyword_font);
    cm_keyword_font = NULL;
  }
  if ((int)cm_normal_font != (int)NULL) {
    gdk_font_unref(cm_normal_font);
    cm_normal_font = NULL;
  }

  /* ɥꥹȤΥݥ󥿤ؤƤ륢ɥХåե */
  current_document->undolist = undo_list_delete (current_document->undolist);
  current_document->undotail = NULL;
  current_document->redolist = undo_list_delete (current_document->redolist);
  current_document->redotail = NULL;
  destroy_current_document();

  /* ܡɥޥΥǡ */
  deinit_key_macro_events();

  /* GListγݤƤХåե */
  cm_dir.glist = g_list_first(cm_dir.glist);
  cm_dir.glist = combo_list_delete(cm_dir.glist);
  cm_ftype.glist = g_list_first(cm_ftype.glist);
  cm_ftype.glist = combo_list_delete(cm_ftype.glist);
  cm_pat.glist = g_list_first(cm_pat.glist);
  cm_pat.glist = combo_list_delete(cm_pat.glist);

  gtk_main_quit();

  return(0);
}

/**************************************
   ꤬ͭ¸ߤ ID ֤
   ꤬ͭ¸ߤʤ-1֤
 **************************************/
/*static int is_shm_not_exist()*/
int is_shm_not_exist()
{
  char *adr;
  char shm_id_buf[256]; /* ͭIDΤΥХåե */
  int ret_db;

  memset(&shm_id_buf[0], 0, sizeof(shm_id_buf));
  ret_db = read_cmemodb("SHAREDMEM", strlen("SHAREDMEM"), &shm_id_buf[0]);
  if (ret_db == -1) {
    return(-1);
  }
  else {
    shared_memory_id = atoi(&shm_id_buf[0]);
  }

  /* ץΥǡȤ˥ޥåפ */
  /* ޥå׽ʤ϶꤬ͭݤƤʤȸȤǤ */
  if ((int)(adr = shmat(shared_memory_id, 0, 0)) == -1) {
    /*perror("shmat");*/
    return(-1);
  }
  else {
    /* ޥåפ */
    if (shmdt(adr) == -1) {
      perror("shmdt");
    }
  }
  return(shared_memory_id);
}

/******************
   ͭ
 ******************/
/*static int create_shared_mem()*/
int create_shared_mem()
{
  char shm_id[256];

  if ((shared_memory_id = shmget(IPC_PRIVATE, 512, IPC_CREAT | 0666)) == -1) {
    perror("shmget");
    return(-1);
  }
  /* debug */
  printf("shared_memory_id = %d\n", shared_memory_id);

  sprintf(&shm_id[0], "%d", shared_memory_id);

  update_cmemodb("SHAREDMEM", strlen("SHAREDMEM"), &shm_id[0]);
  /*update_cmemodb(OPENED_CMEMO, strlen(OPENED_CMEMO), "1");*/  /* "OPENEDCMEMO" */

  return(0);
}

/****************************
   ͭΥǡɤ
 ****************************/
int read_shared_mem(char *data)
{
  char *adr;

  /* ץΥǡȤ˥ޥåפ */
  if ((int)(adr = shmat(shared_memory_id, 0, 0)) == -1) {
    perror("shmat");
    return(-1);
  }
  else {
    strcpy(data, adr);
    /* debug */
    /*printf("%s\n", adr);*/
    /* ޥåפ */
    if (shmdt(adr) == -1) {
      perror("shmdt");
    }
  }

  return(0);
}

/****************************
   ͭ˥ǡ
 ****************************/
int write_shared_mem(char *data)
{
  char *adr;

  /* ץΥǡȤ˥ޥåפ */
  if ((int)(adr = shmat(shared_memory_id, 0, 0)) == -1) {
    perror("shmat");
    return(-1);
  }
  else {
    strcpy(adr, data);
    /* debug */
    /*printf("%s\n", adr);*/
    /* ޥåפ */
    if (shmdt(adr) == -1) {
      perror("shmdt");
    }
  }

  return(0);
}

/*************************************************
   cmemo˥桼ʥ뤬줿Ȥν
 *************************************************/
void cme_usr1_handler(int sig)
{
  char data[1024];
  XWindowAttributes win_attr;
  pid_t pid;

  memset(&data[0], 0, sizeof(data));
  if (read_shared_mem(&data[0]) == 0) {
    /* debug */
    /*printf("%s\n", &data[0]);*/
    if (strncmp(&data[0], "-G", 2) == 0) {
      line_jump(&data[2]);
      gtk_widget_grab_focus(current_document->textbox);
      /*gdk_window_raise(cm_window->window);*/

      XGetWindowAttributes(GDK_DISPLAY(),
                           GDK_WINDOW_XWINDOW(cm_window->window),
                           &win_attr);
      if (win_attr.map_state == IsUnmapped) {
        /* 󲽤䥷ɲƤXSetInputFocus */
        /* 褦ȤΤǥɥɽΤ */
        /* ˤ                                           */
        gdk_window_show(cm_window->window);
      }
      else {
        gdk_window_raise(cm_window->window);
        XSetInputFocus(GDK_DISPLAY(),
                       GDK_WINDOW_XWINDOW(cm_window->window),
                       RevertToNone,
                       GDK_CURRENT_TIME);
      }
    }
    else if (strncmp(&data[0], "-QF", 3) == 0) {
      /*if (read_shared_mem(&data[0]) == 0) {*/
        pid = (pid_t)atoi(&data[3]);
        if (current_document != NULL) {
          if (current_document->filename != NULL) {
            write_shared_mem(current_document->filename);
          }
          else {
            write_shared_mem("data_changed");
          }
        }
        else {
          write_shared_mem("data_changed");
        }
        kill(pid, SIGALRM);
      /*}*/
    }
  }
  signal(SIGUSR1, cme_usr1_handler);
  return;
}

/**************************************************************
   cmemoKILLʥ뤬줿Ȥν...ƯƤʤ
 **************************************************************/
void cme_kill_handler(int sig)
{
  /*int cmemo_count;*/

/*  cmemo_count = count_opened_cmemo();
  if (cmemo_count <= 1) {
*/    /* ݤͭ */
/*    if (shmctl(shared_memory_id, IPC_RMID, 0) == -1) {
      perror("shmctl");
    }
    else {
      g_print("free shared memory : %d\n", shared_memory_id);
    }
  }
*/  gtk_widget_destroy(cm_window);
  return;
}

/****************************
   βʸ
 ****************************/
int clear_cr_lf(char *buf)
{
  char *pos;

  if ((pos = strchr(buf, 0x0d)) != NULL) {
    *pos = 0;
  }
  if ((pos = strchr(buf, 0x0a)) != NULL) {
    *pos = 0;
  }
  return(0);
}

/************************************************
   ե뤬ɥ˥ɥåפ줿ν
 ************************************************/
void drag_data_received_cb(GtkWidget *widget, GdkDragContext *drag_context, 
                           gint x, gint y, GtkSelectionData *data,
                           guint info, guint time, gpointer* data2)
{
  char fname[MAX_PATH];
  char command[MAX_PATH + 32];
  char *pos;
  int i;
  XWindowAttributes win_attr;
  int cmemo_count;
  char pid_buf[32];
  pid_t cme_pid;
  int check_rtn;

  /*printf("data->data %s\n", (char*)data->data);*/
  /*printf("data->length %d\n", (unsigned int)data->length);*/
  if ((pos = strchr((char*)data->data, '/')) != NULL) {
    strcpy(fname, pos);
  }
  else {
    return;
  }
  clear_cr_lf(fname);
  if (gtk_text_get_length(GTK_TEXT(current_document->textbox)) == 0) {
    if (current_document->modified == TRUE) {
      i = warning(" Modified buffers exist.\nDo you open a new text?");
      if (i == 1) {
        return;
      }
    }
    cmemo_count = count_opened_cmemo();
    if (cmemo_count > 1) {
      if (strlen(fname) > 0) {
        /* ȤΥץID */
        cme_pid = getpid();
        sprintf(&pid_buf[0], "%d", cme_pid);
        /* ¹cmemofnameȰפ̾ */
        /* ե򳫤Ƥ뤫å            */
        check_rtn = check_process(&pid_buf[0], fname, "-G0");
        if (check_rtn > 0) {
          return;
        }
      }
    }
    file_open(current_document->textbox, fname);
  }
  else {
    sprintf(command, "cmemo %s &", fname);
    system(command);
    return;
  }

  /* ɥ̤˻ä */
  gtk_widget_grab_focus(current_document->textbox);
  /*gdk_window_raise(cm_window->window);*/
  XGetWindowAttributes(GDK_DISPLAY(),
                       GDK_WINDOW_XWINDOW(cm_window->window),
                       &win_attr);
  if (win_attr.map_state == IsUnmapped) {
    /* 󲽤䥷ɲƤXSetInputFocus */
    /* 褦ȤΤǥɥɽΤ */
    /* ˤ                                           */
    gdk_window_show(cm_window->window);
  }
  else {
    gdk_window_raise(cm_window->window);
    XSetInputFocus(GDK_DISPLAY(),
                   GDK_WINDOW_XWINDOW(cm_window->window),
                   RevertToNone,
                   GDK_CURRENT_TIME);
  }

/*
  if((data->length >= 0) && (data->format == 8)) {
    g_print ("Received \"%s\"\n", data->data);
    gtk_drag_finish(drag_context, TRUE, FALSE, time);
    return;
  }
  gtk_drag_finish(drag_context, FALSE, FALSE, time);
*/
  return;
}

/**************
   ᥤؿ
 **************/
int main(int argc, char *argv[])
{
  GtkWidget *popup_menu_text;
  GtkWidget *popup_menu_entry;
  GtkWidget *popup_menu_search_entry;
  GtkWidget *vbox;
  GtkWidget *hbox;
  GtkAccelGroup *accel_group;
  GtkWidget *scrolled_window;
  GtkWidget *message_entry;
  GtkWidget *bottom_hbox;
  gchar def_font[2048]; /* ĹեȤ̵ */
  gchar entry_text[256];
  gint i; /* ѥ롼ץ */
  char jump_line[10] = {0,0,0,0,0,0,0,0,0,0};
  gint grep_flag = 0;
  gint open_flag = 0;
  pid_t cme_pid;
  int cmemo_count;
  int check_rtn;
  char tmp_buf[1024];
  char open_file_name[1024];
  GtkTargetEntry drop_types[]={{"text/plain", 0, 0}};
  struct stat stbuf;
  char dotcmemorc_path[MAX_PATH + 16];


  /**********************
     ʥϿ
   **********************/
  /* Type of a signal handler.  */
  /*typedef void (*__sighandler_t) (int);*/
  signal(SIGUSR1, cme_usr1_handler);
  signal(SIGALRM, cme_sig_alarm);
  /*signal(SIGKILL, cme_kill_handler);*/
  /*signal(SIGTERM, cme_kill_handler);*/

  /**********************
     Ƽե饰
   **********************/
  init_flags();

  /**********************************
     Ƽѥ򥰥Хѿ˳Ǽ
   **********************************/
  init_path_data();

  /********************
     ͭ
   ********************/
  /*  */
  shared_memory_id = 0;

  /* ꤬ͭޤݤƤʤгݤ */
  if (is_shm_not_exist() == -1) {
    create_shared_mem();
  }
  else {
    /* debug */
    printf("shared_memory_id : %d\n", shared_memory_id);
  }

  /*locale*/
  gtk_set_locale();

  /*ǥեȤο(~/.gtkrcͥ褵)*/
  gtk_rc_parse_string(rcstring);

  /* gtk  */
  gtk_init(&argc, &argv);

  /* ~/.cmemorc¸ߤ硢ɤ߹ */
  /* ϡ~/gtkrcͥ褵      */
  sprintf(dotcmemorc_path, "%s%s", cm_home_path, DOT_CMEMORC);
  if (stat(dotcmemorc_path, &stbuf) != -1) {
    gtk_rc_parse(dotcmemorc_path);
  }

  /*  */
  current_document = NULL;
  memset(&open_file_name[0], 0, sizeof(open_file_name));

  /* ޥɥ饤(ʰ) */
  if (argc > 1) {
    for (i = 1; i < argc; i++) {
      if (strncmp("-G", argv[i], 2) == 0) {
        if (strlen(argv[i]) < 10) {
          strcpy(&jump_line[0], argv[i] + 2);
        }
        else {
          strcpy(&jump_line[0], "error");
        }
        continue;
      }
      else if (strncmp("-g", argv[i], 2) == 0) {
        grep_flag = 1;
      }
      else if (strncmp("-", argv[i], 1) == 0) {
        printf("illegal option (%s)\n", argv[i]);
      }
      else {
      /****************************************************
         ޥɥ饤ǥեǵưޤ
         եޥ͡ǥեɥåɥå
         ν (顼ĴɽԤ)
       ****************************************************/
        if ((*argv[i] != '/') && (getcwd(&tmp_buf[0], sizeof(tmp_buf)) != NULL)) {
          sprintf(&open_file_name[0], "%s/%s", &tmp_buf[0], argv[i]);
        }
        else {
          strcpy(&open_file_name[0], argv[i]);
        }
        open_flag = 1;
/* Get the pathname of the current working directory,
   and put it in SIZE bytes of BUF.  Returns NULL if the
   directory couldn't be determined or SIZE was too small.
   If successful, returns BUF.  In GNU, if BUF is NULL,
   an array is allocated with `malloc'; the array is SIZE
   bytes long, unless SIZE == 0, in which case it is as
   big as necessary.  */
/*extern char *getcwd (char *__buf, size_t __size) __THROW;*/

/*#ifdef	__USE_GNU*/
/* Return a malloc'd string containing the current directory name.
   If the environment variable `PWD' is set, and its value is correct,
   that value is used.  */
/*extern char *get_current_dir_name (void) __THROW;*/
/*#endif*/

/*#if defined __USE_BSD || defined __USE_XOPEN_EXTENDED*/
/* Put the absolute pathname of the current working directory in BUF.
   If successful, return BUF.  If not, put an error message in
   BUF and return NULL.  BUF should be at least PATH_MAX bytes long.  */
/*extern char *getwd (char *__buf) __THROW;*/
/*#endif*/
      }
    }
  }

  cmemo_count = count_opened_cmemo();
  if (cmemo_count > 1) {
    if (strlen(&open_file_name[0]) > 0) {
      char pid_buf[32];
      char tmp_jump_line[32];

      /* ȤΥץID */
      cme_pid = getpid();
      sprintf(&pid_buf[0], "%d", cme_pid);
      /* ¹cmemoopen_file_nameȰפ̾ */
      /* ե򳫤Ƥ뤫å            */
      if (strlen(&jump_line[0]) > 0) {
        sprintf(&tmp_jump_line[0], "-G%s", &jump_line[0]);
      }
      else {
        strcpy(&tmp_jump_line[0], "-G0");
      }
      check_rtn = check_process(&pid_buf[0], &open_file_name[0], &tmp_jump_line[0]);
      if (check_rtn > 0) {
        goto CME_TERMINATION;
        /*exit(0);*/
      }
    }
  }

  /*ե~/.cmemoɤ߹*/
  read_ini();

  /*եȤХɤ*/
  if ((int)cm_key_font[0] != 0) {
    cm_keyword_font = gdk_fontset_load(&cm_key_font[0]);
  }
  if ((int)cm_text_font[0] != 0) {
    cm_normal_font = gdk_fontset_load(&cm_text_font[0]);
    sprintf(&def_font[0], rc_def_font, &cm_text_font[0]);
    /* ƥΰΥǥեȤΥեȤ */
    gtk_rc_parse_string(&def_font[0]);
    /*debug*/
    /*g_print(&def_font[0]);*/
  }


  /******************************
     ᥤ󥦥ɥ
   ******************************/
  /*ɥäơĤ gtk_main_quit Ƥ֤褦*/
  cm_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_events(cm_window, GDK_KEY_RELEASE_MASK);
  gtk_signal_connect(GTK_OBJECT(cm_window), "destroy",
                     GTK_SIGNAL_FUNC(main_win_destroy),
                     (gpointer)cm_window);

  gtk_signal_connect(GTK_OBJECT(cm_window), "destroy_event",
                     GTK_SIGNAL_FUNC(main_win_destroy),
                     (gpointer)cm_window);

  gtk_signal_connect(GTK_OBJECT(cm_window), "delete_event",
                     GTK_SIGNAL_FUNC(main_win_destroy),
                     (gpointer)cm_window);

  accel_group = gtk_accel_group_new();
  gtk_window_add_accel_group(GTK_WINDOW(cm_window), accel_group);


  /***************************
     Drag & Dropб
   ***************************/
  gtk_signal_connect(GTK_OBJECT(cm_window), "drag_data_received",
                     GTK_SIGNAL_FUNC(drag_data_received_cb), NULL);
  gtk_drag_dest_set(cm_window, GTK_DEST_DEFAULT_ALL, drop_types,
                    sizeof(drop_types)/sizeof(drop_types[0]), GDK_ACTION_COPY);


  /**********************
     ƥʤ
   **********************/
  vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_container_add(GTK_CONTAINER(cm_window), vbox);


  /**************************
     ƥΰ
   **************************/
  /*˥塼current_document->textboxѤΤǤǺ*/
  scrolled_window = create_scrolled_text_widget();


  /**********************
     ˥塼
   **********************/
  cm_menu_bar = create_menu(accel_group);
  gtk_widget_show(cm_menu_bar);


  /********************
     ٥
   ********************/
  /* ʲԤϡver.1.1.0ʹߤǤϸܤĴΤ˹ԤäƤ */
  hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hbox);


  /**************************************************************
     ޤϥޥå׻˹ֹ򹹿ؿ³
   **************************************************************/
  /*line_number_cbauto_indent_cb򥳡뤷ʤȹֹɽʤ*/
  gtk_signal_connect_after(GTK_OBJECT(cm_window), "key_press_event",
                           GTK_SIGNAL_FUNC(auto_indent_cb), NULL);
  gtk_signal_connect_after(GTK_OBJECT(cm_window), "key_press_event",
                           GTK_SIGNAL_FUNC(line_number_cb), NULL);
  /*gtk_signal_connect(GTK_OBJECT(current_document->textbox), "key_release_event",
                     GTK_SIGNAL_FUNC(line_number_cb), NULL);*/
  /*gtk_signal_connect(GTK_OBJECT(current_document->textbox), "button_press_event",
                     GTK_SIGNAL_FUNC(line_number_cb), NULL);*/
  gtk_signal_connect(GTK_OBJECT(cm_window), "button_release_event",
                     GTK_SIGNAL_FUNC(line_number_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(cm_window), "key_press_event",
                     GTK_SIGNAL_FUNC(key_macro_cb), current_document);
  gtk_signal_connect(GTK_OBJECT(cm_window), "key_release_event",
                     GTK_SIGNAL_FUNC(key_macro_cb), current_document);


  /********************************************
     ߥ˥Хåեΰ٤οʿܥå
   ********************************************/
  bottom_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(bottom_hbox);


  /****************************************
     ߥ˥Хåեΰϥꥢ
   ****************************************/
  /*ʿܥå˥ȥ꡼åȤ*/
  message_entry = gtk_entry_new();
  gtk_widget_show(message_entry);
  gtk_box_pack_start(GTK_BOX(bottom_hbox), message_entry, TRUE, TRUE, 0);
  init_mlwrite(message_entry);


  /****************************************
     ɥ˳ƥåȤ֤
   ****************************************/
  /* ˥塼С */
  gtk_box_pack_start(GTK_BOX(vbox), cm_menu_bar, FALSE, FALSE, 0);
  /* ܥå */
  gtk_box_pack_start(GTK_BOX(vbox), scrolled_window, TRUE, TRUE, 0);
  /* ܤĴΤοʿܥå */
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 1);
  /* åΰʤɤ֤뤿οʿܥå */
  gtk_box_pack_start(GTK_BOX(vbox), bottom_hbox, FALSE, FALSE, 0);


  /******************************
     ᥤ󥦥ɥγƼ
   ******************************/
  /*ե뤬ɤ߹ᡢ⤵ˣǤʤϤͤ򥻥åȤ*/
  if ((cm_window_width != 0) && (cm_window_height != 0)) {
    gtk_window_set_default_size(GTK_WINDOW(cm_window),
                                cm_window_width,
                                cm_window_height);
  }
  else {
    gtk_window_set_default_size(GTK_WINDOW(cm_window), 630, 550);
  }

  gtk_widget_show(cm_window);
  gtk_widget_grab_focus(current_document->textbox);


  /******************************************
     ưɽΥåȤ
   ******************************************/
  create_hidden_widget(bottom_hbox, &cm_search);


  /**************************************
     ٥˴ؿ³
   **************************************/
  /* cm_jump.entryϲΤ_afterǤĤʤʤȥߤ */
  gtk_signal_connect_after(GTK_OBJECT(cm_jump.entry), "key_press_event",
                           GTK_SIGNAL_FUNC(rtn_key_cb), NULL);
  gtk_signal_connect_after(GTK_OBJECT(cm_search.entry), "key_press_event",
                           GTK_SIGNAL_FUNC(rtn_key_cb), NULL);

  gtk_signal_connect(GTK_OBJECT(cm_search.entry), "focus_in_event",
                     GTK_SIGNAL_FUNC(entry_select_all_cb), NULL);

  gtk_signal_connect(GTK_OBJECT(current_document->textbox), "focus_in_event",
                     GTK_SIGNAL_FUNC(editable_focus_in_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(message_entry), "focus_in_event",
                     GTK_SIGNAL_FUNC(editable_focus_in_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(cm_search.entry), "focus_in_event",
                     GTK_SIGNAL_FUNC(editable_focus_in_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(cm_jump.entry), "focus_in_event",
                     GTK_SIGNAL_FUNC(editable_focus_in_cb), NULL);
  cm_focused_editable = current_document->textbox;

  /*gtk_signal_connect(GTK_OBJECT(cm_window), "key_release_event",
                     GTK_SIGNAL_FUNC(alt_key_cb), NULL);*/
  /*gtk_signal_connect(GTK_OBJECT(cm_window), "key_press_event",
                     GTK_SIGNAL_FUNC(alt_key_cb), NULL);*/


  /**********************************
     ݥåץåץ˥塼
   **********************************/
  /*TextWidgetѥݥåץåץ˥塼*/
  popup_menu_text = create_popup_menu(GTK_WIDGET(current_document->textbox),
                                      1,
                                      accel_group);

  /*EntryWidgetѥݥåץåץ˥塼*/
  popup_menu_entry = create_popup_menu(GTK_WIDGET(message_entry),
                                       0,
                                       accel_group);

  /*EntryWidgetѥݥåץåץ˥塼*/
  popup_menu_search_entry = create_popup_menu(GTK_WIDGET(cm_search.entry),
                                              0,
                                              accel_group);


  /*Хåؿ³*/
  (void)gtk_signal_connect_object(GTK_OBJECT(current_document->textbox),
                                  "event",
                                  GTK_SIGNAL_FUNC(popup_menu_cb),
                                  GTK_OBJECT(popup_menu_text));
  (void)gtk_signal_connect_object(GTK_OBJECT(message_entry),
                                  "event",
                                  GTK_SIGNAL_FUNC(popup_menu_cb),
                                  GTK_OBJECT(popup_menu_entry));
  (void)gtk_signal_connect_object(GTK_OBJECT(cm_search.entry),
                                  "event",
                                  GTK_SIGNAL_FUNC(popup_menu_cb),
                                  GTK_OBJECT(popup_menu_search_entry));


  /**************************************
     Global Search 
   **************************************/
  cm_gsearch_wnd = create_gsearch_wnd();
  /*gtk_widget_show(cm_gsearch_wnd);*/
  /* ᥤ󥦥ɥθ˱Ƥޤʤ褦 */
  gtk_window_set_transient_for(GTK_WINDOW(cm_gsearch_wnd), GTK_WINDOW(cm_window));


  /************************************************
     ⡼ɥ饤˥ǥեȤΥå򥻥å
   ************************************************/
  sprintf(&entry_text[0], MODE_LINE_DEFAULT_MSG, "{0}", "(0)", "L1-C0");
  mlwrite(&entry_text[0], DELAY_UPDATING);


  /************************************
     ޥɥ饤Ϸ̤¹Ԥ
   ************************************/
  if (strlen(&open_file_name[0]) > 0) {
    file_open(current_document->textbox, &open_file_name[0]);
  }
  if (strlen(&jump_line[0]) > 0) {
    line_jump(&jump_line[0]);
  }
  if (grep_flag == 1) {
    if (open_flag == 0) {
      entry_select_all_cb(GTK_WIDGET(cm_pat.entry), NULL);
      gtk_widget_grab_focus(cm_pat.entry);
      gtk_widget_show(cm_gsearch_wnd);
    }
    else {
      printf("can\'t execute option (-g)\n");
    }
  }

  /*ᥤ롼*/
  gtk_main();

CME_TERMINATION:
  /*ưcmemo1İʲʤжͭƽλ*/
  cmemo_count = count_opened_cmemo();
  if (cmemo_count <= 1) {
    /* ݤͭ */
    if (shmctl(shared_memory_id, IPC_RMID, 0) == -1) {
      perror("shmctl");
    }
    else {
      g_print("free shared memory : %d\n", shared_memory_id);
    }
  }
  else if (cmemo_count - 1 == 1) {
    g_print("%d cmemo is still living...\n", cmemo_count - 1);
  }
  else {
    g_print("%d cmemos are still living...\n", cmemo_count - 1);
  }
  cme_pid = getpid();
  g_print("cmemo finished [pid = %u]\n", cme_pid);

  return(0);
}
