/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * ʸĴɽ˴ؤؿ
 */

/*
 * Cmemo : Text Editor
 * coloron.c - source file for syntax highlighting
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "files.h"
#include "coloron.h"
#include "linenum.h"
#include "undo.h"
#include "ini_file.h"
#include "kanji_conv.h"
#include "cme_misc.h"
#include "search.h"
#include "bm_search.h"


/******************************************************
   Խ(ץʤɤ)ϥ⡼ɤؤ
 ******************************************************/
void mode_change_cb(GtkWidget *widget, gpointer data)
{
  struct ftype_info *finf;
  char entry_buf[256];

  finf = (struct ftype_info *)data;
  cm_input_mode = finf->mode_id;
  sprintf(entry_buf, "changed : %s", finf->mode);
  mlwrite(entry_buf, 0);
  /*debug*/
  /*printf("mode = %d\n", cm_input_mode);*/
  return;
}

/******************************
   ߤΥ⡼ɰɽ
 ******************************/
void show_mode_cb(GtkWidget *widget, gpointer data)
{
  char return_mode_buf[32];
  char ignore_case_buf[32];
  char entry_buf[256];
  int i;
  int kanji_idx;

  kanji_idx = 0;
  for (i = 0; i < KMODE_INFO_MAX; i++) {
    if (cm_km_inf[i].mode_id == cm_kanji_mode) {
      kanji_idx = i;
      break;
    }
  }

  switch (cm_return_mode) {
  case CME_LF:
    strcpy(return_mode_buf, "LF");
    break;
  case CME_CR:
    strcpy(return_mode_buf, "CR");
    break;
  case CME_CRLF:
    strcpy(return_mode_buf, "CRLF");
    break;
  default :
    strcpy(return_mode_buf, "LF");
    break;
  }

  switch (cm_ignore_case) {
  case 0:
    strcpy(ignore_case_buf, DONT_IGNORE_CASE);
    break;
  case 1:
    strcpy(ignore_case_buf, IGNORE_CASE);
    break;
  default :
    strcpy(ignore_case_buf, IGNORE_CASE);
    break;
  }

  sprintf(entry_buf,
          "MODE : %s : %s : %s : %s",
          cm_ft_inf[cm_input_mode].mode,
          cm_km_inf[kanji_idx].title,
          return_mode_buf,
          ignore_case_buf);
  mlwrite(entry_buf, 0);

  return;
}

/******************************************************
   Ctrl+Lʤɤǲ̤Υ顼ɽեå夹ؿ
 ******************************************************/
void color_on_cb(GtkWidget *widget, gpointer data)
{
  gint position;
  gfloat value;
  gchar *buf;
  gint len;
  filestruct *doc;
  char entry_buf[256];


  mlwrite(CME_WAIT, 0);
  doc = current_document;

  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->ins_txt_id);
  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->del_txt_id);

  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->line_ins_id);
  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->line_del_id);

  value = GTK_TEXT(doc->textbox)->vadj->value;
  position = gtk_editable_get_position(GTK_EDITABLE(GTK_TEXT(doc->textbox)));

  /* gtk_text_get_lengthͤʸΤ褦Ǥ */
  len = gtk_text_get_length(GTK_TEXT(doc->textbox));
  buf = gtk_editable_get_chars(GTK_EDITABLE(doc->textbox), 0, len);
  if (buf != NULL) {
    gtk_editable_delete_text(GTK_EDITABLE(doc->textbox), 0, len);
    color_on(doc->textbox, buf);
    /*line_number_init_cb(buf, len);*/
    g_free(buf);
    /*g_print("color on: %s\n", doc->filename);*/
  }

  gtk_adjustment_set_value(GTK_ADJUSTMENT(GTK_TEXT(doc->textbox)->vadj), value);

  gtk_editable_set_position(GTK_EDITABLE(GTK_TEXT(doc->textbox)), position);

  doc->ins_txt_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "insert_text",
                                       GTK_SIGNAL_FUNC(doc_insert_text_cb), doc);
  doc->del_txt_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "delete_text",
                                       GTK_SIGNAL_FUNC(doc_delete_text_cb), doc);

  doc->line_ins_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "insert_text",
                                        GTK_SIGNAL_FUNC(line_count_insert), doc);
  doc->line_del_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "delete_text",
                                        GTK_SIGNAL_FUNC(line_count_delete), doc);

  sprintf(entry_buf, "refreshed (current line %d)", get_cur_line_number());
  mlwrite(entry_buf, 0);

  return;
}

/***********************************************
   Alt+Lʤɤǲ̤Υ顼ɽ̵ˤؿ
 ***********************************************/
void color_off_cb(GtkWidget *widget, gpointer data)
{
  gint position;
  gfloat value;
  gchar *buf;
  gint len;
  filestruct *doc;
  char entry_buf[256];


  mlwrite(CME_WAIT, 0);
  doc = current_document;

  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->ins_txt_id);
  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->del_txt_id);

  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->line_ins_id);
  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->line_del_id);

  value = GTK_TEXT(doc->textbox)->vadj->value;
  position = gtk_editable_get_position(GTK_EDITABLE(GTK_TEXT(doc->textbox)));

  /* gtk_text_get_lengthͤʸΤ褦Ǥ */
  len = gtk_text_get_length(GTK_TEXT(doc->textbox));
  buf = gtk_editable_get_chars(GTK_EDITABLE(doc->textbox), 0, len);
  if (buf != NULL) {
    gtk_editable_delete_text(GTK_EDITABLE(doc->textbox), 0, len);
    /* 顼ɽ򥪥դˤեȤ.cmemoΤΤȤ */
    gtk_text_insert(GTK_TEXT(doc->textbox),
                    cm_normal_font, &cm_base_color, NULL,
                    buf, strlen(buf));
    /*line_number_init_cb(buf, len);*/
    g_free(buf);
    /*g_print("color off:  %s\n", doc->filename);*/
  }

  gtk_adjustment_set_value(GTK_ADJUSTMENT(GTK_TEXT(doc->textbox)->vadj), value);

  gtk_editable_set_position(GTK_EDITABLE(GTK_TEXT(doc->textbox)), position);

  doc->ins_txt_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "insert_text",
                                       GTK_SIGNAL_FUNC(doc_insert_text_cb), doc);
  doc->del_txt_id = gtk_signal_connect(GTK_OBJECT (doc->textbox), "delete_text",
                                       GTK_SIGNAL_FUNC(doc_delete_text_cb), doc);

  doc->line_ins_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "insert_text",
                                        GTK_SIGNAL_FUNC(line_count_insert), doc);
  doc->line_del_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "delete_text",
                                        GTK_SIGNAL_FUNC(line_count_delete), doc);

  sprintf(entry_buf, "refreshed (current line %d)", get_cur_line_number());
  mlwrite(entry_buf, 0);

  return;
}

/********************************************************************
   ƥȥåȤ˥ƥȤ򥫥顼ɽؿؤδؿ
 ********************************************************************/
void color_on(gpointer text, gchar *textbuf)
{
  int len;

  /* öߤ */
  gtk_text_freeze(GTK_TEXT(text));

  /* ƥȾõ */
  len = gtk_text_get_length(GTK_TEXT(text));
  gtk_editable_delete_text(GTK_EDITABLE(GTK_TEXT(text)), 0, len);

  /* ʸϤʤƥȤ򥫥顼ɽ */
  insert_colored_text(text, textbuf, &cm_ft_inf[cm_input_mode]);

  /* 褹 */
  gtk_text_thaw(GTK_TEXT(text));

  return;
}

/******************************************************************
   ʸϤƥƥȥåȤ˥ƥȤ򥫥顼ɽؿ
 ******************************************************************/
void insert_colored_text(void *gtext, char *textbuf, void *data)
{
  int i;
  int text_len;
  char *ps;
  char *pe;
  int flag;
  int cmt_start_len;
  int cmt_end_len;
  int line_cmt_len;
  int rtn_chr_len;
  char *find_pos;
  char key[32];
  int key_ins_flag;
  int key_len;
  int bm_rtn;
  struct ftype_info *finf;

  finf = (struct ftype_info *)data;
  ps = textbuf;
  pe = textbuf;
  flag = 0;
  text_len = strlen(textbuf);
  cmt_start_len = strlen(finf->cmt_start);
  cmt_end_len = strlen(finf->cmt_end);
  line_cmt_len = strlen(finf->line_cmt);
  rtn_chr_len = strlen("\n");
  cm_base_color = finf->base_color;
  cm_key1_color = finf->key1_color;
  cm_key2_color = finf->key2_color;
  cm_number_color = finf->num_color;
  cm_comment_color = finf->cmt_color;
  cm_string_color = finf->str_color;

  while ((*ps != '\0') || (ps < textbuf + text_len)) {
    while (*pe != '\0') {
      if ((memcmp(pe, finf->cmt_start, cmt_start_len) == 0) &&
          (cmt_start_len != 0)) {
        flag = CME_COMMENT;
        break;
      }
      else if ((memcmp(pe, finf->line_cmt, line_cmt_len) == 0) &&
               (line_cmt_len != 0)) {
        flag = CME_LINE_COMMENT;
        break;
      }
      else if (*pe == finf->str_start) {
        flag = CME_STRING;
        break;
      }
      else if (*pe == finf->chr_start) {
        flag = CME_CHARACTER;
        break;
      }
      else if ((*pe >= '0') && (*pe <= '9')) {
        flag = CME_NUMBER;
        break;
      }
      else if (strchr(finf->delimiter, *pe) != NULL) {
        flag = CME_DELIMITER;
        break;
      }
      else {
       pe++;
      }
    }

    key_len = pe - ps;
    key_ins_flag = 0;
    /* ɤ⤷ʤ */
    if ((key_len < sizeof(key)) && (key_len > 0)) {
      memset(key, 0, sizeof(key));
      memcpy(key, ps, key_len);

      /* ɣǤХ顼ɽ */
      if (key_ins_flag == 0) {
        find_pos = finf->key1buf;
        do {
          /*find_pos = strstr(find_pos, key);*/
          bm_rtn = bm_search(find_pos, strlen(find_pos), key, key_len,
                             finf->ignore_case);
          /*if (find_pos != NULL) {*/
          if (bm_rtn > -1) {
            find_pos = find_pos + bm_rtn;
            if (((find_pos == finf->key1buf) || (*(find_pos - 1) == ';')) &&
                ((*(find_pos + key_len) == ';') || (*(find_pos + key_len) == '\0'))) {
              gtk_text_insert(GTK_TEXT(gtext), cm_keyword_font,
                              &cm_key1_color,NULL, key, key_len);
              key_ins_flag = 1;
              break;
            }
          }
          else {
            break;
          }
          find_pos++;
        } while (1);
      }

      /* ɣǤʤɣǤХ顼ɽ */
      if (key_ins_flag == 0) {
        find_pos = finf->key2buf;
        do {
          /*find_pos = strstr(find_pos, key);*/
          bm_rtn = bm_search(find_pos, strlen(find_pos), key, key_len,
                             finf->ignore_case);
          /*if (find_pos != NULL) {*/
          if (bm_rtn > -1) {
            find_pos = find_pos + bm_rtn;
            if (((find_pos == finf->key2buf) || (*(find_pos - 1) == ';')) &&
                ((*(find_pos + key_len) == ';') || (*(find_pos + key_len) == '\0'))) {
              gtk_text_insert(GTK_TEXT(gtext), cm_keyword_font,
                              &cm_key2_color, NULL, key, key_len);
              key_ins_flag = 1;
              break;
            }
          }
          else {
            break;
          }
          find_pos++;
        } while (1);
      }
    }

    /* ɤǤϤʤ */
    if (key_ins_flag == 0) {
      gtk_text_insert(GTK_TEXT(gtext), cm_normal_font,
                      &cm_base_color, NULL, ps, key_len);
    }
    /*ps = ps + key_len;*/
    ps = pe;

    /* ե饰ͤˤäƽʬ */
    switch (flag) {
    case CME_COMMENT:
      bm_rtn = bm_search(ps, strlen(ps), finf->cmt_end, cmt_end_len, 0);
      if (bm_rtn > -1) {
        pe = pe + bm_rtn + cmt_end_len;
      }
      else {
        pe = pe + strlen(ps);
      }
      gtk_text_insert(GTK_TEXT(gtext), cm_normal_font,
                      &cm_comment_color, NULL, ps, pe - ps);
      ps = pe;
      break;
    case CME_LINE_COMMENT:
      bm_rtn = bm_search(ps, strlen(ps), "\n", rtn_chr_len, 0);
      if ((bm_rtn > -1)) {
        pe = pe + bm_rtn + rtn_chr_len;
      }
      else {
        pe = pe + strlen(ps);
      }
      gtk_text_insert(GTK_TEXT(gtext), cm_normal_font,
                      &cm_comment_color, NULL, ps, pe - ps);
      ps = pe;
      break;
    case CME_STRING:
      while (*pe != '\0') {
        pe++;
        if (*pe == finf->str_end) {
          i = 0;
          while ((*(pe - i - 1) == finf->esc_chr) && ((pe - i - 1) >= textbuf)) {
            i++;
          }
          if ((i % 2) == 0) {
            pe++;
            break;
          }
        }
      }
      gtk_text_insert(GTK_TEXT(gtext), cm_normal_font,
                      &cm_string_color, NULL, ps, pe - ps);
      ps = pe;
      break;
    case CME_CHARACTER:
      while (*pe != '\0') {
        pe++;
        if (((*pe == finf->chr_end) && (*(pe - 1) != finf->esc_chr)) ||
            ((*pe == finf->chr_end) && (*(pe - 1) == finf->esc_chr) &&
             (*(pe - 2) == finf->esc_chr))) {
          pe++;
          break;
        }
      }
      gtk_text_insert(GTK_TEXT(gtext), cm_normal_font,
                      &cm_number_color, NULL, ps, pe - ps);
      ps = pe;
      break;
    case CME_NUMBER:
      while (*pe != '\0') {
        pe++;
        if ((*pe < '0') || (*pe > '9')) {
          break;
        }
      }
      gtk_text_insert(GTK_TEXT(gtext), cm_normal_font,
                      &cm_number_color, NULL, ps, pe - ps);
      ps = pe;
      break;
    case CME_DELIMITER:
      while (*pe != '\0') {
        pe++;
        if ((strchr(finf->delimiter, *pe) == NULL) ||
            (*pe == finf->cmt_start[0]) ||
            (*pe == finf->line_cmt[0]) ||
            (*pe == finf->str_start) ||
            (*pe == finf->chr_start)){
          break;
        }
      }
      gtk_text_insert(GTK_TEXT(gtext), cm_normal_font,
                      &cm_base_color, NULL, ps, pe - ps);
      ps = pe;
      break;
    default:
      gtk_text_insert(GTK_TEXT(gtext), cm_normal_font,
                      &cm_base_color, NULL, ps, pe - ps);
      ps = pe;
      break;
    }
  }
  return;
}
