/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * եΥץ󥻡֤˴ؤؿ
 */

/*
 * Cmemo : Text Editor
 * files.c - source file for loading or saving files
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include "cme_def.h"
#include "cmemo.h"
#include "coloron.h"
#include "files.h"
#include "linenum.h"
#include "undo.h"
#include "ini_file.h"
#include "warning.h"
#include "kanji_conv.h"
#include "cme_misc.h"
#include "utf8.h"


int cm_input_mode; /* ϥ⡼(C C++ etc)(cm_ft_inf[]ֹ) */
int cm_kanji_mode; /* ⡼(euc-jp etc)(cm_km_inf[]ֹ) */
int cm_return_mode; /* ʸμ(CR LF CRLF)ɽХѿ */
struct ftype_info cm_ft_inf[FTYPE_INFO_MAX]; /* ϥ⡼ɤ빽¤ */
struct kmode_info cm_km_inf[KMODE_INFO_MAX]; /* ⡼ɤ빽¤ */

static int load_type = AUTOMATIC; /* ɤ߹ʸɼưȽ̤ɤ */
static struct file_open fo; /* ե륪ץ¤ */

/* local declarations */
static int file_save(char *save_fname, gpointer text);


/**********************************************
   ԽΥեʸɤؤ
 **********************************************/
void set_kanji_mode(GtkWidget *widget, gpointer data)
{
  struct kmode_info *kinf;
  char entry_buf[256];

  kinf = (struct kmode_info *)data;
  cm_kanji_mode = kinf->mode_id;
  sprintf(entry_buf, "Changed Kanji Code : %s", kinf->title);
  mlwrite(entry_buf, 0);

  /*ʸɤꤷϼΥեɤ߹߻˼ưȽ̤򤷤ʤ*/
  /*MANUALǰɤ߹load_typeAUTOMATICˤɤ*/
  load_type = MANUAL;

  return;
}

/********************************************
   ԽΥեβʸؤ
 ********************************************/
void set_return_mode(GtkWidget *widget, gpointer mode)
{
  cm_return_mode = (int)mode;

  switch ((int)mode) {
  case CME_LF:
    mlwrite("Return Code : LF", 0);
    break;
  case CME_CR:
    mlwrite("Return Code : CR", 0);
    break;
  case CME_CRLF:
    mlwrite("Return Code : CRLF", 0);
    break;
  default :
    mlwrite("Return Code : LF", 0);
    break;
  }

  return;
}

/**************************************************
   ˥ե뤬ɥåפ줿ޤϥ
   ɥ饤ǥե̾ꤵ줿ν
 **************************************************/
void file_open(gpointer text, gchar *fname)
{
  current_document->filename = fo.filename;
  strcpy(current_document->filename, fname);

  what_file(NULL, (gpointer)text);

  return;
}

/********************************************************
   ftype_info¤Τ򥵡ƥե륿פꤹ
 ********************************************************/
int get_file_type(char *dot)
{
  int i;
  char *find_pos;

  for (i = 0; i < FTYPE_INFO_MAX; i++) {
    find_pos = cm_ft_inf[i].ext;
    if (find_pos == NULL) {
      continue;
    }
    do {
      find_pos = strstr(find_pos, dot);
      if (find_pos != NULL) {
        if ((*(find_pos + strlen(dot)) == ';') ||
            (*(find_pos + strlen(dot)) == '\0')) {
          return(i);
        }
      }
      else {
        break;
      }
      find_pos++;
    } while (1);
  }
  return(0);
}

/************************************************************
   ե򳫤ν򤷡ok_cb_open򥳡뤹ؿ
 ************************************************************/
void what_file(GtkWidget *widget, gpointer text)
{
  char *tmp;
  pid_t cme_pid;
  char pid_buf[32];
  int check_rtn;
  filestruct *doc;

  doc = current_document;

  if (widget != NULL) {
    /* widgetNULLǤʤȤȤϥץOK줿 */
    /* fo.filenameƤfo.tmpfilename˰ö򤹤 */
    memcpy(fo.tmpfilename, fo.filename, sizeof(fo.tmpfilename));
    doc->filename = fo.filename;
    strcpy(doc->filename,
           gtk_file_selection_get_filename(GTK_FILE_SELECTION(fo.open_dlg)));
    cancel_cb(NULL, NULL);

    /* ե뤬˳Ƥ뤫ɤå */
    if (strlen(doc->filename) > 0) {
      /* ȤΥץID */
      cme_pid = getpid();
      sprintf(&pid_buf[0], "%d", cme_pid);
      /* ¹cmemoˤäopen_file_nameȰפ  */
      /* ̾Υե뤬˳Ƥ뤫å */
      check_rtn = check_process(&pid_buf[0], doc->filename, "-G0");
      if (check_rtn > 0) {
        /* Ǥ˥ե뤬ƤΤǤǤϳʤ */
        printf("the file \"%s\" is already opened\n", doc->filename);
        /* 򤷤ƤǡѤƥե̾򸵤᤹ */
        memcpy(fo.filename, fo.tmpfilename, sizeof(fo.filename));
        return;
      }
    }
  }

  mlwrite(CME_WAIT, 0);

  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->ins_txt_id);
  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->del_txt_id);

  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->line_ins_id);
  gtk_signal_disconnect(GTK_OBJECT(doc->textbox), doc->line_del_id);

  tmp = strrchr(doc->filename, '.');

  /*ĥҤˤäƥեΥפȽ̤*/
  if (tmp != NULL) {
    cm_input_mode = get_file_type(tmp);
  }
  else {
    cm_input_mode = 0;
  }
  ok_cb_open(widget, text, doc->filename, cm_input_mode);

  doc->undolist = undo_list_delete(doc->undolist);
  doc->undotail = NULL;
  doc->redolist = undo_list_delete(doc->redolist);
  doc->redotail = NULL;

  doc->ins_txt_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "insert_text",
                                       GTK_SIGNAL_FUNC(doc_insert_text_cb), doc);
  doc->del_txt_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "delete_text",
                                       GTK_SIGNAL_FUNC(doc_delete_text_cb), doc);

  doc->line_ins_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "insert_text",
                                        GTK_SIGNAL_FUNC(line_count_insert), doc);
  doc->line_del_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "delete_text",
                                        GTK_SIGNAL_FUNC(line_count_delete), doc);

  return;
}

/********************************************************************************
   ե򳫤ƥȥåȤɽ롢ޤcolor_on򥳡뤹ؿ
 ********************************************************************************/
void ok_cb_open(GtkWidget *widget, gpointer text, gchar *filename, int file_type)
{
  FILE *fp;
  /*char buf[1024];*/
  unsigned int len;
  unsigned char *buf;
  unsigned char *dest_buf;
  struct stat stbuf;
  int size;
  unsigned int new_len;
  int i;


  /*freadΤ˳"rb"(Хʥ)ǳ*/
  if ((fp = fopen(filename, "rb")) != NULL) {
    /*öƥȤߤ*/
    gtk_text_freeze(GTK_TEXT(text));

    /*ƥȾõ*/
    len = gtk_text_get_length(GTK_TEXT(text));
    gtk_editable_delete_text(GTK_EDITABLE(GTK_TEXT(text)), 0, len);
    /*ˡȤޤ˾꤯ԤʤȤΤǾ嵭ˡѤ*/
    /*gtk_text_backward_delete(GTK_TEXT(text),
			     gtk_text_get_length(GTK_TEXT(text)));*/

    /*ʲɤ߹ˡ Ver.1.0.1c ʹ߻ѤǤʤʤä*/
    /*while(fgets(buf, 1024, fp) != NULL) {
      gtk_text_insert(GTK_TEXT(text), cm_normal_font, &cm_base_color,
                      NULL, buf, strlen(buf));
    }*/

    /*եޤ뤴ȥɤ߹ǥƥȥåȤ˥å*/
    /*ե륹ȥ꡼फ飱Ԥɤ߹ˡ¿ΥȤ*/
    stat(filename, &stbuf);
    size = stbuf.st_size + 1; /*̥ʸʬ*/

    /*ե륵ʬ*/
    buf = (unsigned char *)malloc((unsigned)size);

    if (buf != NULL) {
      memset(buf, 0, size);
      /*Хåե˥ƥȥեɤ߹*/
      /*̥ʸʬäʤ褦˵դ*/
      fread(buf, sizeof(char), size - 1, fp);

      if (load_type == AUTOMATIC) {
        /*ʸɤȽꤹ*/
        cm_kanji_mode = what_kanji_code(buf);
      }
      else {
        /*ʸɻɤ߹硢ɤ߹߻ˤϼư᤹*/
        load_type = AUTOMATIC;
      }

      switch (cm_kanji_mode) {
      case EUC_JP:
        break;
      case SHIFT_JIS:
        /*Shift-JisȾѲ̾ʸä硢EUCǤϣܤΰ褬ɬ*/
        dest_buf = (unsigned char *)malloc((unsigned)(size * 2));
        if (dest_buf != NULL) {
          memset(dest_buf, 0, size * 2);
          sjis_to_euc(dest_buf, buf);
          free(buf);
          buf = dest_buf;
        }
        else {
          free(buf);
          mlwrite("Memory Full", 0);
          g_print("Memory Full %s\n", current_document->filename);
          fclose(fp);
          return;
        }
        break;
      case JIS2022:
        /*JISɤξ硢ѴEUCJIS¿ΰȤȤϤʤ*/
        dest_buf = (unsigned char *)malloc((unsigned)size);
        if (dest_buf != NULL) {
          memset(dest_buf, 0, size);
          jis_to_euc(dest_buf, buf);
          free(buf);
          buf = dest_buf;
        }
        else {
          free(buf);
          mlwrite("Memory Full", 0);
          g_print("Memory Full %s\n", current_document->filename);
          fclose(fp);
          return;
        }
        break;
      case UTF_8:
        /* UTF-8ξ硢ѴEUCUTF-8¿ΰȤȤϤʤ */
        /* âCJKʸξǤա                     */
        dest_buf = (unsigned char *)malloc((unsigned)size);
        if (dest_buf != NULL) {
          memset(dest_buf, 0, size);
          utf8_main("-ue", buf, dest_buf);
          free(buf);
          buf = dest_buf;
        }
        else {
          free(buf);
          mlwrite("Memory Full", 0);
          g_print("Memory Full %s\n", current_document->filename);
          fclose(fp);
          return;
        }
        break;
      case ASCII:
        break;
      default :
        break;
      }
      
      /*ƥȾõ*/
      /*gtk_editable_delete_text(GTK_EDITABLE(GTK_TEXT(text)), 0, len);*/

      /*ƤβʸLFѴ*/
      cm_return_mode = all_to_lf(buf);

      /* 礭ʥեξ */
      if (size > CME_READ_LIMIT) {
        /* warning()ƤӽФȲΤ */
        /* warning()gtk_main()ιԤ */
        /* ϸ(2001/08/18)ǤǤ */
        /*i = warning(FILE_SIZE_WARNING);*/
        i = 1;
        if (i == 1) {
          gtk_text_insert(GTK_TEXT(text), cm_normal_font,
                          &cm_base_color, NULL, buf, -1);
        }
        else {
          /*ƥȥåȤ˥ƥȤ򥫥顼ɽؿ򥳡 */
          color_on(GTK_TEXT(text), buf);
        }
      }
      else {
        /*ƥȥåȤ˥ƥȤ򥫥顼ɽؿ򥳡 */
        color_on(GTK_TEXT(text), buf);
      }

      /*եĤ*/
      fclose(fp);
    }
    else {
      mlwrite("Memory Full", 0);
      g_print("Memory Full %s\n", current_document->filename);
      fclose(fp);
      return;
    }
    /*free(buf);*/

    /*ƥȥåȺ*/
    gtk_text_thaw(GTK_TEXT(text));

    new_len = gtk_text_get_length(GTK_TEXT(text));
    if ((new_len != 0) && ((size >> 2) <= new_len)) {
      /*ߥ˥Хåե˥ե̾ɽ*/
      mlwrite(current_document->filename, 0);
    }
    else {
      /* sizeͤ(ե륵+1)ʤΤǡ */
      /* 1ʲʤХե륵0Ǥ   */
      if (size > 1) {
        open_hex(text, (unsigned char *)filename);
        cm_kanji_mode = BINARY;

        free(buf);
        len = gtk_text_get_length(GTK_TEXT(text));
        buf = gtk_editable_get_chars(GTK_EDITABLE(text), 0, len);
      }
      else {
        mlwrite("the file is empty", 0);
      }
    }

    /*󥽡˥ե̾ɽ*/
    g_print("%s\n", current_document->filename);

    /*ɥ˥ե̾ɽ*/
    gtk_window_set_title(GTK_WINDOW(cm_window), current_document->filename);

    /*ֹ׻ΤΥǡ*/
    if (buf != NULL) {
      /* ܤΰˤgtk_text_get_lengthͤϤ */
      len = gtk_text_get_length(GTK_TEXT(text));
      line_number_init_cb(buf, len);
    }
    else {
      /* ⤷open_hexopen_bad_codeΥХåեݤ */
      /* ԤƤʤ顢⤦٥ȥ饤Ƥߤ      */
      free(buf);
      len = gtk_text_get_length(GTK_TEXT(text));
      buf = gtk_editable_get_chars(GTK_EDITABLE(text), 0, len);
      line_number_init_cb(buf, len);
    }

    /*ɤ߹ƥȥǡ꤫鳫*/
    free(buf);

    /*̤б֤ͤ*/
    init_kakko_count();

    /*Խѥե饰*/
    current_document->modified = FALSE;
  }
  else {
    /*ե륪ץ˼*/
    mlwrite("Open Error", 0);
    g_print("Open Error %s\n", current_document->filename);
  }
  return;
}

/**********************
   ե¸
 **********************/
static int file_save(char *save_fname, gpointer text)
{
  FILE *fp;
  unsigned char *buf;
  unsigned char *dest_buf;
  unsigned int len;
  char message[1024];


  buf = NULL;
  dest_buf = NULL;

  /*fwriteΤ˳"wb"(Хʥ)ǳ*/
  if ((fp = fopen(save_fname, "wb")) != NULL) {
    buf = gtk_editable_get_chars(GTK_EDITABLE(GTK_TEXT(text)), 0, -1);

    if (buf == NULL) {
      mlwrite("Memory Full", 0);
      g_print("Memory Full %s\n", save_fname);
      fclose(fp);
      return(-1);
    }

    /*NULLʸХʬ˺ʤ褦len˲ä*/
    len = strlen(buf) + 1;

    /* ASCII⡼ɤξ¸륳ɤEUCɤĴ٤ */
    if (cm_kanji_mode == ASCII) {
      /* ʸûShift-JisȸǧΤ */
      /* ASCIIǤʤEUC˺ؤ                    */
      if (what_kanji_code(buf) != ASCII) {
        cm_kanji_mode = EUC_JP;
      }
    }

    switch (cm_kanji_mode) {
    case EUC_JP:
      break;
    case SHIFT_JIS:
      /* EUCShift-JisѴϸΰۤ뤳Ȥ̵ */
      dest_buf = (unsigned char *)malloc(len);
      if (dest_buf != NULL) {
        memset(dest_buf, 0, len);
        euc_to_sjis(dest_buf, buf);
        free(buf);
        buf = dest_buf;
      }
      else {
        free(buf);
        mlwrite("Memory Full", 0);
        g_print("Memory Full %s\n", current_document->filename);
        fclose(fp);
        return(-1);
      }
      break;
    case JIS2022:
      /* JisEUCѴ硢ɤΰѰդɤ */
      /* ԳʤΤǡeuc_to_jis򥳡뤹euc_to_jis_size  */
      /* 򥳡뤷ɬפΰĴ٤ʤФʤʤ             */
      /* NULLʸХʬ˺ʤ褦len˲ä              */
      len = euc_to_jis_size(buf) + 1;
      dest_buf = (unsigned char *)malloc(len);
      if (dest_buf != NULL) {
        memset(dest_buf, 0, len);
        euc_to_jis(dest_buf, buf);
        free(buf);
        buf = dest_buf;
      }
      else {
        free(buf);
        mlwrite("Memory Full", 0);
        g_print("Memory Full %s\n", current_document->filename);
        fclose(fp);
        return(-1);
      }
      break;
    case UTF_8:
      /* EUCUTF-8Ѵϸΰ2ܤнʬǤ */
      dest_buf = (unsigned char *)malloc(len * 2);
      if (dest_buf != NULL) {
        memset(dest_buf, 0, len * 2);
        utf8_main("-eu", buf, dest_buf);
        free(buf);
        buf = dest_buf;
      }
      else {
        free(buf);
        mlwrite("Memory Full", 0);
        g_print("Memory Full %s\n", current_document->filename);
        fclose(fp);
        return(-1);
      }
      break;
    case ASCII:
      break;
    default :
      break;
    }

    /* ʸѴĹƼ */
    len = strlen(buf) + 1;

    switch (cm_return_mode) {
    case CME_LF:
      break;
    case CME_CR:
      lf_to_cr(buf);
      break;
    case CME_CRLF:
      dest_buf = (unsigned char *)malloc(len + cm_all_lines);
      if (dest_buf != NULL) {
        memset(dest_buf, 0, len + cm_all_lines);
        lf_to_crlf(dest_buf, buf);
        free(buf);
        buf = dest_buf;
      }
      else {
        free(buf);
        mlwrite("Memory Full", 0);
        g_print("Memory Full %s\n", current_document->filename);
        fclose(fp);
        return(-1);
      }
      break;
    default :
      break;
    }

    /*fprintf(fp, "%s", buf);*/
    fwrite(buf, sizeof(unsigned char), strlen(buf), fp);
    fclose(fp);
    free(buf);
    if (strlen(current_document->filename) < (sizeof(message) - strlen("Wrote "))) {
      sprintf(message, "Wrote %s", current_document->filename);
    }
    else {
      sprintf(message, "Wrote %s", "[too long filename]");
    }
    mlwrite(&message[0], 0);
    current_document->modified = FALSE;
    g_print("Wrote %s\n", current_document->filename);
    gtk_window_set_title(GTK_WINDOW(cm_window), current_document->filename);
  }
  else {
    mlwrite("Save failed", 0);
    g_print("Save failed %s\n", current_document->filename);
    return(-1);
  }
  return(0);
}

/****************************************************
   Save as OKå줿Ȥν
 ****************************************************/
void ok_cb_save(GtkWidget *widget, gpointer text)
{
  struct stat stbuf;
  int i;

  /*ʸɻɤ߹Ǥ硢ɤ߹ߤϼưˤʤ褦ˤ*/
  load_type = AUTOMATIC;

  /* fo.filenameƤfo.tmpfilename˰ö򤹤 */
  memcpy(fo.tmpfilename, fo.filename, sizeof(fo.tmpfilename));
  current_document->filename = fo.filename;
  strcpy(current_document->filename,
         gtk_file_selection_get_filename(GTK_FILE_SELECTION(fo.open_dlg)));

  if (stat(current_document->filename, &stbuf) != -1) {
    i = warning(" The file already exists.\nAre you ok to overwrite?");
    if (i == 1) {
      /* 򤷤ƤǡѤƥե̾򸵤᤹ */
      memcpy(fo.filename, fo.tmpfilename, sizeof(fo.filename));
      return;
    }
  }
  cancel_cb(NULL, NULL);
  file_save(current_document->filename, text);
  return;
}

/***************
   ¸
 ***************/
void save_text(GtkWidget *widget, gpointer text)
{
  /*struct stat stbuf;*/

  /*Хʥե򳫤Ƥޤä˸äƾ񤭤ʤ褦ˤ*/
  if (cm_kanji_mode == BINARY) {
    mlwrite("SORRY! THIS MIGHT BE A BINARY FILE. CMEMO CAN NOT SAVE BINARY FILES.", 0);
    return;
  }

  if (current_document->modified == FALSE) {
    mlwrite(NO_CHANGE_NEED, 0);
    return;
  }

  /* ¸ޤϥե̾դ¸ */
  if (current_document->filename == NULL) {
    /* ե̾ؤΥݥ󥿤NULLξ */
    save_as_text(widget, text);
  }
  else if (strlen(current_document->filename) == 0) {
    /* ե̾Ĺ0ξ */
    save_as_text(widget, text);
  }
  /*else if (stat(current_document->filename, &stbuf) == -1) {*/
    /* ꤵ줿̾Υե뤬¸ߤʤ */
    /* cmemoǳƤ˺ʤ¤ꤢʤ */
    /*save_as_text(widget, text);*/
  /*}*/
  else {
    file_save(current_document->filename, text);
  }

  return;
}

/************************************************
   Cancelå줿Ȥν
 ************************************************/
void cancel_cb(GtkWidget *widget, gpointer text)
{
  gtk_grab_remove(fo.open_dlg);
  gtk_widget_destroy(fo.open_dlg);
  return;
}

/********************************
   ˴ν
 ********************************/
void destroy_cb(GtkWidget *widget, gpointer text)
{
  gtk_main_quit();
  return;
}

/*************************
   Open ɽ
 *************************/
void open_text(GtkWidget *widget, gpointer text)
{
  int i;
  int x;
  int y;
  int width;
  int height;
  int dlg_width;
  int dlg_height;
  int dlg_pos_x;
  int dlg_pos_y;

  if (current_document->modified == TRUE) {
    i = warning(" Modified buffers exist.\nDo you open a new text?");
    if (i == 1) {
      return;
    }
  }

  fo.open_dlg = gtk_file_selection_new("Open file");

  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(fo.open_dlg));

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)->ok_button),
		     "clicked", GTK_SIGNAL_FUNC(what_file), text);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)->cancel_button),
		     "clicked", GTK_SIGNAL_FUNC(cancel_cb), NULL);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)), "destroy",
		     GTK_SIGNAL_FUNC(destroy_cb), NULL);

  if (current_document->filename != NULL) {
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(fo.open_dlg),
                                    current_document->filename);
  }

  /* ᥤ󥦥ɥθ˱Ƥޤʤ褦 */
  gtk_window_set_transient_for(GTK_WINDOW(fo.open_dlg), GTK_WINDOW(cm_window));

  /* ᥤ󥦥ɥ֤ */
  gdk_window_get_position(cm_window->window, &x, &y);
  gdk_window_get_size(cm_window->window, &width, &height);
  gtk_widget_realize(fo.open_dlg);
  gdk_window_get_size(fo.open_dlg->window, &dlg_width, &dlg_height);
  dlg_pos_x = x + (width - dlg_width) / 2;
  dlg_pos_y = y + (height - dlg_height) / 2;
  gtk_widget_set_uposition(fo.open_dlg,
                           (dlg_pos_x > 0) ? dlg_pos_x : 0,
                           (dlg_pos_y > 0) ? dlg_pos_y : 0);

  gtk_widget_show(fo.open_dlg);

  gtk_grab_add(fo.open_dlg);

  gtk_main();

  /*gtk_grab_remove(fo.open_dlg);*/

  return;
}

/****************************
   Save as ɽ
 ****************************/
void save_as_text(GtkWidget *widget, gpointer text)
{
  int x;
  int y;
  int width;
  int height;
  int dlg_width;
  int dlg_height;
  int dlg_pos_x;
  int dlg_pos_y;


  fo.open_dlg = gtk_file_selection_new("Save file as...");

  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(fo.open_dlg));

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)->ok_button),
		     "clicked", GTK_SIGNAL_FUNC(ok_cb_save), text);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)->cancel_button),
		     "clicked", GTK_SIGNAL_FUNC(cancel_cb), NULL);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fo.open_dlg)), "destroy",
		     GTK_SIGNAL_FUNC(destroy_cb), NULL);

  if (current_document->filename != NULL) {
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(fo.open_dlg),
                                    current_document->filename);
  }

  /* ᥤ󥦥ɥθ˱Ƥޤʤ褦 */
  gtk_window_set_transient_for(GTK_WINDOW(fo.open_dlg), GTK_WINDOW(cm_window));

  /* ᥤ󥦥ɥ֤ */
  gdk_window_get_position(cm_window->window, &x, &y);
  gdk_window_get_size(cm_window->window, &width, &height);
  gtk_widget_realize(fo.open_dlg);
  gdk_window_get_size(fo.open_dlg->window, &dlg_width, &dlg_height);
  dlg_pos_x = x + (width - dlg_width) / 2;
  dlg_pos_y = y + (height - dlg_height) / 2;
  gtk_widget_set_uposition(fo.open_dlg,
                           (dlg_pos_x > 0) ? dlg_pos_x : 0,
                           (dlg_pos_y > 0) ? dlg_pos_y : 0);

  gtk_widget_show(fo.open_dlg);

  gtk_grab_add(fo.open_dlg);

  gtk_main();

  /*gtk_grab_remove(fo.open_dlg);*/

  return;
}

/************************************************
   Хʥե16ʥפɽؿ
 ************************************************/
void open_hex(gpointer text, unsigned char *fname)
{
  FILE *input_fp;
  unsigned char *buf;
  struct stat stbuf;
  unsigned int size;
  unsigned int line_num;
  unsigned int i;
  unsigned char line_text[1024];
  unsigned char ascii_text[1024];


  mlwrite(PLEASE_WAIT, 0);

  i = warning(BINARY_WARNING);
  if (i == 1) {
    mlwrite("not opened", 0);
    return;
  }

  memset(&line_text[0], 0, 1024);
  memset(&ascii_text[0], 0, 1024);
  ascii_text[0] = ' ';

  /*freadΤ˳"rb"(Хʥ)ǳ*/
  if ((input_fp = fopen(fname, "rb")) != NULL) {
    gtk_text_freeze(GTK_TEXT(text));
    gtk_editable_delete_text(GTK_EDITABLE(GTK_TEXT(text)), 0, -1);

    stat(fname, &stbuf);
    size = stbuf.st_size;

    /*ե륵ʬ*/
    buf = (unsigned char *)malloc(size);

    if (buf != NULL) {
      memset(buf, 0, size);
      /*ХʥեȤƽ뤿ե륵Ԥäɤ߹*/
      fread(buf, sizeof(char), size, input_fp);
      line_num = 0;
      for (i = 0; i < size; i++) {
        if ((i % 16) == 0) {
          /*sprintf(&line_text[strlen(line_text)], "%06d : ", line_num);*/
          sprintf(&line_text[strlen(line_text)], "%08x : ", line_num);
          /*line_num++;*/
          line_num = line_num + 16;
        }

        sprintf(&line_text[strlen(line_text)], "%02x ", buf[i]);

        if (((int)buf[i] >= 0x20) && ((int)buf[i] <= 0x7e)) {
          ascii_text[(i % 16) + 1] = buf[i];
        }
        else {
          ascii_text[(i % 16) + 1] = '.';
        }

        if ((i % 16) == 7) {
          sprintf(&line_text[strlen(line_text)], "- ");
        }
        else if ((i % 16) == 15) {
          sprintf(&line_text[strlen(line_text)], "%s", &ascii_text[0]);
          sprintf(&line_text[strlen(line_text)], "\n");
          gtk_text_insert(GTK_TEXT(text), cm_normal_font, &cm_base_color, NULL,
                          &line_text[0], strlen(&line_text[0]));
          memset(&line_text[0], 0, 1024);
          memset(&ascii_text[0], 0, 1024);
          ascii_text[0] = ' ';
        }
      }
      if ((strlen(line_text) < BIN_FORMAT) && (strlen(line_text) != 0)) {
        memset(&line_text[strlen(line_text)], 0x20, BIN_FORMAT - strlen(line_text));
        sprintf(&line_text[strlen(line_text)], "%s", &ascii_text[0]);
        sprintf(&line_text[strlen(line_text)], "\n");
        gtk_text_insert(GTK_TEXT(text), cm_normal_font, &cm_base_color, NULL,
                        &line_text[0], strlen(&line_text[0]));
      }
      free(buf);
    }
    gtk_text_thaw(GTK_TEXT(text));
    fclose(input_fp);
    mlwrite(fname, 0);
    g_print("%s\n", fname);
    gtk_window_set_title(GTK_WINDOW(cm_window), fname);
    current_document->filename = fo.filename;
    strcpy(current_document->filename, fname);
    current_document->modified = FALSE;
  }
  else {
    mlwrite("Open Error", 0);
    g_print("Open Error %s\n", fname);
  }

  return;
}

/*******************
   cmemoư
 *******************/
void new_window(GtkWidget *widget, gpointer text)
{
  system("cmemo &");
}
