/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * 󥿡ե뤿δؿ
 */

/*
 * Cmemo : Text Editor
 * interface.c - source file for  building interface
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "files.h"
#include "linenum.h"
#include "coloron.h"
#include "document.h"
#include "undo.h"
#include "warning.h"
#include "search.h"
#include "ini_file.h"
#include "interface.h"
#include "kanji_conv.h"
#include "cme_misc.h"
#include "global_search.h"
#include "jump.h"
#include "keys.h"


struct combo_struct cm_dir;
struct combo_struct cm_ftype;
struct combo_struct cm_pat;
GtkWidget *cm_match_chk_btn;
GtkWidget *cm_regex_chk_btn;

/* local declarations */
static int create_lang_menu(GtkWidget *lang_menu, GtkAccelGroup *accel_group);
static int create_mode_menu(GtkWidget *mode_menu);


/**********************************
   ƥȥåȤ
 **********************************/
GtkWidget *create_scrolled_text_widget(void)
{
  GtkWidget *scrolled_window;

  /*ƥȤ롣*/
  current_document = new_document ();
  gtk_widget_show(current_document->textbox);

  /**********************
     ƥΰ
   **********************/
  /*ܥå롣*/
  scrolled_window = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
                                 GTK_POLICY_ALWAYS,  /* h_scrollbar */
                                 GTK_POLICY_ALWAYS); /* v_scrollbar */
  gtk_widget_show(scrolled_window);

  /* ƥȥåȤ򥹥ܥåξ֤ */
  gtk_container_add(GTK_CONTAINER(scrolled_window), current_document->textbox);
  gtk_widget_show(current_document->textbox);

  return(scrolled_window);
}

/********************
   Lang˥塼
 ********************/
static int create_lang_menu(GtkWidget *lang_menu, GtkAccelGroup *accel_group)
{
  int i;
  GtkWidget *sub_item;

  /* ftype_info¤Τξ˽äLang˥塼 */
  for (i = 0; i < FTYPE_INFO_MAX; i++) {
    cm_ft_inf[i].mode_id = i;
    if (cm_ft_inf[i].data_flag == 0) {
      continue;
    }
    sub_item = gtk_menu_item_new_with_label(cm_ft_inf[i].title);
    gtk_menu_append(GTK_MENU(lang_menu), sub_item);
    gtk_widget_add_accelerator(sub_item, "activate",
                               accel_group, cm_ft_inf[i].acckey,
                               GDK_SHIFT_MASK | GDK_MOD1_MASK, 1);
    gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
                       GTK_SIGNAL_FUNC(mode_change_cb),
                       &cm_ft_inf[i]);
    if (cm_ft_inf[i].enabled == 0) {
      gtk_widget_set_sensitive(sub_item, FALSE);
    }
    gtk_widget_show(sub_item);
  }
  return(0);
}

/********************
   Mode˥塼
 ********************/
static int create_mode_menu(GtkWidget *mode_menu)
{
  int i;
  GtkWidget *sub_item;

  /*(ʸɥ⡼)*/
  /* kmode_info¤Τξ˽äLang˥塼 */
  for (i = 0; i < KMODE_INFO_MAX; i++) {
    /*cm_km_inf[i].mode_id = i;*/
    if (cm_km_inf[i].data_flag == 0) {
      continue;
    }
    sub_item = gtk_menu_item_new_with_label(cm_km_inf[i].title);
    gtk_menu_append(GTK_MENU(mode_menu), sub_item);
    gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
                       GTK_SIGNAL_FUNC(set_kanji_mode),
                       &cm_km_inf[i]);
    if (cm_km_inf[i].enabled == 0) {
      gtk_widget_set_sensitive(sub_item, FALSE);
    }
    gtk_widget_show(sub_item);
  }
  return(0);
}

/************************************
   ˥塼С˥˥塼
 ************************************/
GtkWidget *create_menu(GtkAccelGroup *accel_group)
{
  GtkWidget *menu_bar;
  GtkWidget *sub_item;
  GtkWidget *file_menu;
  GtkWidget *file_item;
  GtkWidget *edit_menu;
  GtkWidget *edit_item;
  GtkWidget *search_menu;
  GtkWidget *search_item;
  GtkWidget *cmd_menu;
  GtkWidget *cmd_item;
  GtkWidget *lang_menu;
  GtkWidget *lang_item;
  GtkWidget *mode_menu;
  GtkWidget *mode_item;
  GtkWidget *help_menu;
  GtkWidget *help_item;
  GtkWidget *hsep;
  guint tmp_key;

  menu_bar = gtk_menu_bar_new();
  /* ˥塼СαƤϤδؿκǸ˰ư */
  /*gtk_menu_bar_set_shadow_type (GTK_MENU_BAR(menu_bar), GTK_SHADOW_NONE);*/
  gtk_widget_show(menu_bar);


  /********************************
     ˥塼 "File" (ե)
   ********************************/
  file_menu = gtk_menu_new();

  sub_item = gtk_menu_item_new_with_label("New Window");
  gtk_menu_append(GTK_MENU(file_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'N', GDK_MOD1_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
                     GTK_SIGNAL_FUNC(new_window),
                     (gpointer)current_document->textbox);
  gtk_widget_show(sub_item);

  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(file_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  sub_item = gtk_menu_item_new_with_label("Open");
  gtk_menu_append(GTK_MENU(file_menu), sub_item);
  /*gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'O', GDK_MOD1_MASK, 1);*/
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'I', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
                     GTK_SIGNAL_FUNC(open_text),
                     (gpointer)current_document->textbox);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Save");
  gtk_menu_append(GTK_MENU(file_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'S', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(save_text),(gpointer)current_document->textbox);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Save as");
  gtk_menu_append(GTK_MENU(file_menu), sub_item);
  /*gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'S', GDK_MOD1_MASK, 1);*/
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'W', GDK_MOD1_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(save_as_text),(gpointer)current_document->textbox);
  gtk_widget_show(sub_item);

  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(file_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  sub_item = gtk_menu_item_new_with_label("Print...");
  gtk_menu_append(GTK_MENU(file_menu), sub_item);
  /*gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'R', GDK_MOD1_MASK, 1);*/
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(print_cb), NULL);
  gtk_widget_set_sensitive(sub_item, FALSE);
  gtk_widget_show(sub_item);

  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(file_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  sub_item = gtk_menu_item_new_with_label("Exit");
  gtk_menu_append(GTK_MENU(file_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'Q', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(main_win_destroy), (gpointer)cm_window);
  gtk_widget_show(sub_item);
/*
  file_item = gtk_menu_item_new_with_label("File");
  gtk_widget_show(file_item);
*/
  file_item = gtk_menu_item_new_with_label("");
  tmp_key = gtk_label_parse_uline(GTK_LABEL(GTK_BIN(file_item)->child), "_File");
  gtk_widget_add_accelerator(file_item, "activate_item", accel_group,
                             tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name(file_item, "file_item");
  gtk_widget_ref(file_item);
  gtk_object_set_data_full(GTK_OBJECT (cm_window), "file_item", file_item,
                           (GtkDestroyNotify)gtk_widget_unref);
  gtk_widget_show(file_item);

  gtk_menu_item_set_submenu(GTK_MENU_ITEM(file_item), file_menu);

  gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), file_item);


  /****************************
     ˥塼 "Edit" (Խ)
   ****************************/
  edit_menu = gtk_menu_new();

  sub_item = gtk_menu_item_new_with_label("Undo");
  gtk_menu_append(GTK_MENU(edit_menu), sub_item);
  /*gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             '/', GDK_CONTROL_MASK, 1);*/
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'Z', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item),"activate",
		     GTK_SIGNAL_FUNC(undo_cb), (gpointer)current_document->textbox);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Redo");
  gtk_menu_append(GTK_MENU(edit_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'R', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item),"activate",
		     GTK_SIGNAL_FUNC(redo_cb), (gpointer)current_document->textbox);
  gtk_widget_show(sub_item);

  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(edit_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  sub_item = gtk_menu_item_new_with_label("Copy");
  gtk_menu_append(GTK_MENU(edit_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'C', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(edit_copy), NULL);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Cut");
  gtk_menu_append(GTK_MENU(edit_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'X', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(edit_cut), NULL);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Paste");
  gtk_menu_append(GTK_MENU(edit_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'V', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(edit_paste), NULL);
  gtk_widget_show(sub_item);

  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(edit_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  sub_item = gtk_menu_item_new_with_label("Select All");
  gtk_menu_append(GTK_MENU(edit_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'A', GDK_MOD1_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(select_all_cb), NULL);
  gtk_widget_show(sub_item);
/*
  edit_item = gtk_menu_item_new_with_label("Edit");
  gtk_widget_show(edit_item);
*/
  edit_item = gtk_menu_item_new_with_label("");
  tmp_key = gtk_label_parse_uline(GTK_LABEL(GTK_BIN(edit_item)->child), "_Edit");
  gtk_widget_add_accelerator(edit_item, "activate_item", accel_group,
                             tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name(edit_item, "edit_item");
  gtk_widget_ref(edit_item);
  gtk_object_set_data_full(GTK_OBJECT (cm_window), "edit_item", edit_item,
                           (GtkDestroyNotify)gtk_widget_unref);
  gtk_widget_show(edit_item);

  gtk_menu_item_set_submenu(GTK_MENU_ITEM(edit_item), edit_menu);

  gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), edit_item);


  /******************************
     ˥塼 "Search" ()
   ******************************/
  search_menu = gtk_menu_new();

  sub_item = gtk_menu_item_new_with_label("Find...");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'X', GDK_MOD1_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(search_visi_cb), NULL);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Find Dlg Open");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'G', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(search_open_cb), NULL);
  /*gtk_widget_show(sub_item);*/

  /*  */
  sub_item = gtk_menu_item_new_with_label("Search Dn");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'Y', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(dn_search), NULL);
  gtk_widget_show(sub_item);

  /* (ɽ) */
  sub_item = gtk_menu_item_new_with_label("Search Dn");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             GDK_F3, 0, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(dn_search), NULL);
  /*gtk_widget_show(sub_item);*/

  /* 帡 */
  sub_item = gtk_menu_item_new_with_label("Search Up");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'T', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(up_search), NULL);
  gtk_widget_show(sub_item);

  /* 帡(ɽ) */
  sub_item = gtk_menu_item_new_with_label("Search Up");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             GDK_F4, 0, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(up_search), NULL);
  /*gtk_widget_show(sub_item);*/

  sub_item = gtk_menu_item_new_with_label("Ignore Case ?");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
                     GTK_SIGNAL_FUNC(case_on_off), NULL);
  gtk_widget_show(sub_item);

  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(search_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  sub_item = gtk_menu_item_new_with_label("Jump to...");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'J', GDK_MOD1_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(jump_visi_cb), NULL);
  gtk_widget_show(sub_item);

  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(search_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  sub_item = gtk_menu_item_new_with_label("Tag Jump");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'K', GDK_MOD1_MASK, 1);
  /*gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             GDK_F10, 0, 1);*/
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(tag_jump_cb), NULL);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Global Search");
  gtk_menu_append(GTK_MENU(search_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'G', GDK_MOD1_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
       GTK_SIGNAL_FUNC(gsearch_run_cb), NULL);
  gtk_widget_show(sub_item);
/*
  search_item = gtk_menu_item_new_with_label("Search");
  gtk_widget_show(search_item);
*/
  search_item = gtk_menu_item_new_with_label("");
  tmp_key = gtk_label_parse_uline(GTK_LABEL(GTK_BIN(search_item)->child), "_Search");
  gtk_widget_add_accelerator(search_item, "activate_item", accel_group,
                             tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name(search_item, "search_item");
  gtk_widget_ref(search_item);
  gtk_object_set_data_full(GTK_OBJECT (cm_window), "search_item", search_item,
                           (GtkDestroyNotify)gtk_widget_unref);
  gtk_widget_show(search_item);

  gtk_menu_item_set_submenu(GTK_MENU_ITEM(search_item), search_menu);

  gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), search_item);


  /****************************
     ˥塼 "Cmd" (Command)
   ****************************/
  cmd_menu = gtk_menu_new();

  sub_item = gtk_menu_item_new_with_label("color on");
  gtk_menu_append(GTK_MENU(cmd_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'L', GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(color_on_cb), NULL);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("color off");
  gtk_menu_append(GTK_MENU(cmd_menu), sub_item);
  /*gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'L', GDK_MOD1_MASK, 1);*/
  /*gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'M', GDK_CONTROL_MASK, 1);*/
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'L', GDK_CONTROL_MASK | GDK_MOD1_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(color_off_cb), NULL);
  gtk_widget_show(sub_item);

  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(cmd_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  sub_item = gtk_menu_item_new_with_label("play key macro");
  gtk_menu_append(GTK_MENU(cmd_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'O', GDK_SHIFT_MASK | GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(key_macro_play_cb), NULL);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("record key macro");
  gtk_menu_append(GTK_MENU(cmd_menu), sub_item);
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'R', GDK_SHIFT_MASK | GDK_CONTROL_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(key_macro_record_cb), NULL);
  gtk_widget_show(sub_item);
/*
  cmd_item = gtk_menu_item_new_with_label("View");
  gtk_widget_show(cmd_item);
*/
  cmd_item = gtk_menu_item_new_with_label("");
  tmp_key = gtk_label_parse_uline(GTK_LABEL(GTK_BIN(cmd_item)->child), "_Cmd");
  gtk_widget_add_accelerator(cmd_item, "activate_item", accel_group,
                             tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name(cmd_item, "cmd_item");
  gtk_widget_ref(cmd_item);
  gtk_object_set_data_full(GTK_OBJECT (cm_window), "cmd_item", cmd_item,
                           (GtkDestroyNotify)gtk_widget_unref);
  gtk_widget_show(cmd_item);

  gtk_menu_item_set_submenu(GTK_MENU_ITEM(cmd_item), cmd_menu);

  gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), cmd_item);


  /*******************
     ˥塼 "Lang"
   *******************/
  /*()*/
  lang_menu = gtk_menu_new();

  /*ftype_info¤ΤΥǡ˽äƥ˥塼 */
  create_lang_menu(lang_menu, accel_group);

  /*(ե륿)*/
/*
  lang_item = gtk_menu_item_new_with_label("Lang");
  gtk_widget_show(lang_item);
*/
  lang_item = gtk_menu_item_new_with_label("");
  tmp_key = gtk_label_parse_uline(GTK_LABEL(GTK_BIN(lang_item)->child), "_Lang");
  gtk_widget_add_accelerator(lang_item, "activate_item", accel_group,
                             tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name(lang_item, "lang_item");
  gtk_widget_ref(lang_item);
  gtk_object_set_data_full(GTK_OBJECT (cm_window), "lang_item", lang_item,
                           (GtkDestroyNotify)gtk_widget_unref);
  gtk_widget_show(lang_item);

  /*˥塼"Lang"˥å*/
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(lang_item), lang_menu);

  gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), lang_item);


  /*******************
     ˥塼 "Mode"
   *******************/
  /*(Ƽ⡼)*/
  mode_menu = gtk_menu_new();

  /*kmode_info¤ΤΥǡ˽äƥ˥塼 */
  create_mode_menu(mode_menu);

  /*ѥ졼*/
  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(mode_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  /*(ʸΥ⡼)*/
  sub_item = gtk_menu_item_new_with_label("CR");
  gtk_menu_append(GTK_MENU(mode_menu), sub_item);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
                     GTK_SIGNAL_FUNC(set_return_mode),
                     (gpointer)CME_CR);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("LF");
  gtk_menu_append(GTK_MENU(mode_menu), sub_item);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
                     GTK_SIGNAL_FUNC(set_return_mode),
                     (gpointer)CME_LF);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("CRLF");
  gtk_menu_append(GTK_MENU(mode_menu), sub_item);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
                     GTK_SIGNAL_FUNC(set_return_mode),
                     (gpointer)CME_CRLF);
  gtk_widget_show(sub_item);

  /*ѥ졼*/
  hsep = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(mode_menu), hsep);
  gtk_widget_set_sensitive(hsep, FALSE);
  gtk_widget_show(hsep);

  /*⡼ɤߥ˥Хåեɽ*/
  sub_item = gtk_menu_item_new_with_label("Show Mode");
  gtk_menu_append(GTK_MENU(mode_menu), sub_item);
  /*gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'M', GDK_MOD1_MASK, 1);*/
  gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             'M', GDK_CONTROL_MASK | GDK_MOD1_MASK, 1);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
                     GTK_SIGNAL_FUNC(show_mode_cb), NULL);
  gtk_widget_show(sub_item);

  /*⡼*/
/*
  mode_item = gtk_menu_item_new_with_label("Mode");
  gtk_widget_show(mode_item);
*/
  mode_item = gtk_menu_item_new_with_label("");
  tmp_key = gtk_label_parse_uline(GTK_LABEL(GTK_BIN(mode_item)->child), "_Mode");
  gtk_widget_add_accelerator(mode_item, "activate_item", accel_group,
                             tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name(mode_item, "mode_item");
  gtk_widget_ref(mode_item);
  gtk_object_set_data_full(GTK_OBJECT (cm_window), "mode_item", mode_item,
                           (GtkDestroyNotify)gtk_widget_unref);
  gtk_widget_show(mode_item);

  /*⡼ɥ˥塼"Mode"˥å*/
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(mode_item), mode_menu);

  gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), mode_item);


  /******************************
     ˥塼 "Help" ()
   ******************************/
  help_menu = gtk_menu_new();

  sub_item = gtk_menu_item_new_with_label("Settings...");
  gtk_menu_append(GTK_MENU(help_menu), sub_item);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(show_ini), NULL);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Version Info");
  gtk_menu_append(GTK_MENU(help_menu), sub_item);
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(version_cb), NULL);
  gtk_widget_show(sub_item);
/*
  help_item = gtk_menu_item_new_with_label("Help");
  gtk_widget_show(help_item);
*/
  help_item = gtk_menu_item_new_with_label("");
  tmp_key = gtk_label_parse_uline(GTK_LABEL(GTK_BIN(help_item)->child), "_Help");
  gtk_widget_add_accelerator(help_item, "activate_item", accel_group,
                             tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name(help_item, "help_item");
  gtk_widget_ref(help_item);
  gtk_object_set_data_full(GTK_OBJECT (cm_window), "help_item", help_item,
                           (GtkDestroyNotify)gtk_widget_unref);
  gtk_widget_show(help_item);

  gtk_menu_item_set_submenu(GTK_MENU_ITEM(help_item), help_menu);

  gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), help_item);

  gtk_menu_item_right_justify(GTK_MENU_ITEM(help_item));

  /* ˥塼Сι⤵ */
  gtk_widget_set_usize(menu_bar, -2, 22);
  /* Ǹ˥˥塼СαƤ̵(եå)ꤹ */
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR(menu_bar), GTK_SHADOW_NONE);

  return(menu_bar);
}

/**********************************
   ݥåץåץ˥塼
 **********************************/
GtkWidget *create_popup_menu(GtkWidget *widget,
                             int text_entry,
                             GtkAccelGroup *accel_group)
{
  GtkWidget *popup_menu;
  GtkWidget *sub_item;
  GtkWidget *hsep;

  /*ݥåץåץ˥塼*/
  popup_menu = gtk_menu_new();

  sub_item = gtk_menu_item_new_with_label("Copy");
  gtk_menu_append(GTK_MENU(popup_menu), sub_item);
  if (text_entry == 1) {
    gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                             GDK_F6, 0, 1);
  }
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(edit_copy), (gpointer)widget);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Cut");
  gtk_menu_append(GTK_MENU(popup_menu), sub_item);
  if (text_entry == 1) {
    gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                               GDK_F7, 0, 1);
  }
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(edit_cut), (gpointer)widget);
  gtk_widget_show(sub_item);

  sub_item = gtk_menu_item_new_with_label("Paste");
  gtk_menu_append(GTK_MENU(popup_menu), sub_item);
  if (text_entry == 1) {
    gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                               GDK_F8, 0, 1);
  }
  gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
		     GTK_SIGNAL_FUNC(edit_paste), (gpointer)widget);
  gtk_widget_show(sub_item);

  if (text_entry == 1) {
    hsep = gtk_menu_item_new();
    gtk_menu_append(GTK_MENU(popup_menu), hsep);
    gtk_widget_set_sensitive(hsep, FALSE);
    gtk_widget_show(hsep);

    sub_item = gtk_menu_item_new_with_label("Select All");
    gtk_menu_append(GTK_MENU(popup_menu), sub_item);
    gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                               GDK_F9, 0, 1);
    gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
               GTK_SIGNAL_FUNC(select_all_cb), NULL);
    gtk_widget_show(sub_item);

    hsep = gtk_menu_item_new();
    gtk_menu_append(GTK_MENU(popup_menu), hsep);
    gtk_widget_set_sensitive(hsep, FALSE);
    gtk_widget_show(hsep);

    sub_item = gtk_menu_item_new_with_label("Tag Jump");
    gtk_menu_append(GTK_MENU(popup_menu), sub_item);
    gtk_widget_add_accelerator(sub_item, "activate", accel_group,
                               GDK_F10, 0, 1);
    gtk_signal_connect(GTK_OBJECT(sub_item), "activate",
               GTK_SIGNAL_FUNC(tag_jump_cb), NULL);
    gtk_widget_show(sub_item);
  }

  return popup_menu;
}

/******************************************
   ưɽΥåȤ
 ******************************************/
int create_hidden_widget(GtkWidget *bottom_hbox, struct search_struct *srch_obj)
{
  /*帡ѥܥ*/
  srch_obj->button_up = gtk_button_new_with_label("up");
  gtk_box_pack_start(GTK_BOX(bottom_hbox), srch_obj->button_up, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(srch_obj->button_up), "clicked",
                     GTK_SIGNAL_FUNC(up_search), NULL);
  gtk_button_set_relief(GTK_BUTTON(srch_obj->button_up),GTK_RELIEF_NONE);

  /*ѥܥ*/
  srch_obj->button_dn = gtk_button_new_with_label("dn");
  gtk_box_pack_start(GTK_BOX(bottom_hbox), srch_obj->button_dn, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(srch_obj->button_dn), "clicked",
                     GTK_SIGNAL_FUNC(dn_search), NULL);
  gtk_button_set_relief(GTK_BUTTON(srch_obj->button_dn),GTK_RELIEF_NONE);

  /*ʸϤEntryWidgetκ*/
  srch_obj->entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(bottom_hbox), srch_obj->entry, FALSE, FALSE, 0);
  gtk_entry_set_editable(GTK_ENTRY(srch_obj->entry), TRUE);

  /*ԥѥܥ*/
  cm_jump.button = gtk_button_new_with_label("jump");
  gtk_box_pack_start(GTK_BOX(bottom_hbox), cm_jump.button, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(cm_jump.button), "clicked",
                     GTK_SIGNAL_FUNC(line_jump_cb), NULL);
  gtk_button_set_relief(GTK_BUTTON(cm_jump.button),GTK_RELIEF_NONE);

  /*פֹϤEntryWidgetκ*/
  cm_jump.entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(bottom_hbox), cm_jump.entry, FALSE, FALSE, 0);
  gtk_entry_set_editable(GTK_ENTRY(cm_jump.entry), TRUE);

  return(0);
}

/************************************************
   Х륵ѥɥκ
 ************************************************/
/* δؿ Glade ΤԽƺ */
GtkWidget *create_gsearch_wnd(void)
{
  GtkWidget *gsearch_wnd;
  GtkWidget *vbox;
  GtkWidget *dummy_hbox;
  GtkWidget *dummy_label;
  GtkWidget *dir_hbox;
  GtkWidget *dir_label;
  GtkWidget *sel_btn;
  GtkWidget *ftype_hbox;
  GtkWidget *ftype_label;
  GtkWidget *pat_hbox;
  GtkWidget *pat_label;
  GtkWidget *opt_hbox;
  GtkWidget *ok_btn;
  GtkWidget *cancel_btn;


  gsearch_wnd = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (gsearch_wnd), "gsearch_wnd", gsearch_wnd);
  gtk_widget_set_usize (gsearch_wnd, 400, 104);
  gtk_window_set_title (GTK_WINDOW (gsearch_wnd), "global search");
  gtk_window_set_position (GTK_WINDOW (gsearch_wnd), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (gsearch_wnd), TRUE);
  gtk_window_set_policy (GTK_WINDOW (gsearch_wnd), FALSE, FALSE, FALSE);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "vbox", vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (gsearch_wnd), vbox);

  dummy_hbox = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (dummy_hbox);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "dummy_hbox", dummy_hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dummy_hbox);
  gtk_box_pack_start (GTK_BOX (vbox), dummy_hbox, TRUE, TRUE, 0);
  gtk_widget_set_usize (dummy_hbox, -2, 3);

  dummy_label = gtk_label_new ("");
  gtk_widget_ref (dummy_label);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "dummy_label", dummy_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dummy_label);
  gtk_box_pack_start (GTK_BOX (dummy_hbox), dummy_label, TRUE, TRUE, 0);

  dir_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (dir_hbox);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "dir_hbox", dir_hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dir_hbox);
  gtk_box_pack_start (GTK_BOX (vbox), dir_hbox, TRUE, FALSE, 0);

  dir_label = gtk_label_new (" directory ");
  gtk_widget_ref (dir_label);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "dir_label", dir_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dir_label);
  gtk_box_pack_start (GTK_BOX (dir_hbox), dir_label, FALSE, FALSE, 0);

  cm_dir.combo = gtk_combo_new ();
  gtk_widget_ref (cm_dir.combo);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "dir_combo", cm_dir.combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cm_dir.combo);
  gtk_box_pack_start (GTK_BOX (dir_hbox), cm_dir.combo, TRUE, TRUE, 0);

  cm_dir.entry = GTK_COMBO (cm_dir.combo)->entry;
  gtk_widget_ref (cm_dir.entry);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "dir_entry", cm_dir.entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cm_dir.entry);

  sel_btn = gtk_button_new_with_label (" Select ");
  gtk_widget_ref (sel_btn);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "sel_btn", sel_btn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_btn);
  gtk_box_pack_start (GTK_BOX (dir_hbox), sel_btn, FALSE, TRUE, 0);

  gtk_signal_connect (GTK_OBJECT (sel_btn), "clicked",
                      GTK_SIGNAL_FUNC (sel_btn_cb),
                      (gpointer)gsearch_wnd);

  ftype_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (ftype_hbox);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "ftype_hbox", ftype_hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ftype_hbox);
  gtk_box_pack_start (GTK_BOX (vbox), ftype_hbox, TRUE, FALSE, 0);

  ftype_label = gtk_label_new (" filetype  ");
  gtk_widget_ref (ftype_label);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "ftype_label", ftype_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ftype_label);
  gtk_box_pack_start (GTK_BOX (ftype_hbox), ftype_label, FALSE, FALSE, 0);

  cm_ftype.combo = gtk_combo_new ();
  gtk_widget_ref (cm_ftype.combo);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "ftype_combo", cm_ftype.combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cm_ftype.combo);
  gtk_box_pack_start (GTK_BOX (ftype_hbox), cm_ftype.combo, TRUE, TRUE, 0);

  cm_ftype.entry = GTK_COMBO (cm_ftype.combo)->entry;
  gtk_widget_ref (cm_ftype.entry);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "ftype_entry", cm_ftype.entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cm_ftype.entry);

  pat_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (pat_hbox);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "pat_hbox", pat_hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pat_hbox);
  gtk_box_pack_start (GTK_BOX (vbox), pat_hbox, TRUE, FALSE, 0);

  pat_label = gtk_label_new (" pattern   ");
  gtk_widget_ref (pat_label);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "pat_label", pat_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pat_label);
  gtk_box_pack_start (GTK_BOX (pat_hbox), pat_label, FALSE, FALSE, 0);

  cm_pat.combo = gtk_combo_new ();
  gtk_widget_ref (cm_pat.combo);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "pat_combo", cm_pat.combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cm_pat.combo);
  gtk_box_pack_start (GTK_BOX (pat_hbox), cm_pat.combo, TRUE, TRUE, 0);

  cm_pat.entry = GTK_COMBO (cm_pat.combo)->entry;
  gtk_widget_ref (cm_pat.entry);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "pat_entry", cm_pat.entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cm_pat.entry);

  opt_hbox = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (opt_hbox);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "opt_hbox", opt_hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (opt_hbox);
  gtk_box_pack_start (GTK_BOX (vbox), opt_hbox, TRUE, TRUE, 0);
  gtk_widget_set_usize (opt_hbox, -2, 25);
  gtk_container_set_border_width (GTK_CONTAINER (opt_hbox), 2);

  cm_match_chk_btn = gtk_check_button_new_with_label ("match case");
  gtk_widget_ref (cm_match_chk_btn);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "match_chk_btn",
                            cm_match_chk_btn, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cm_match_chk_btn);
  gtk_box_pack_start (GTK_BOX (opt_hbox), cm_match_chk_btn, FALSE, FALSE, 0);

  cm_regex_chk_btn = gtk_check_button_new_with_label ("regex");
  gtk_widget_ref (cm_regex_chk_btn);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "regex_chk_btn",
                            cm_regex_chk_btn, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cm_regex_chk_btn);
  gtk_box_pack_start (GTK_BOX (opt_hbox), cm_regex_chk_btn, FALSE, FALSE, 0);

  ok_btn = gtk_button_new_with_label ("OK");
  gtk_widget_ref (ok_btn);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "ok_btn", ok_btn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_btn);
  gtk_box_pack_start (GTK_BOX (opt_hbox), ok_btn, FALSE, TRUE, 0);

  cancel_btn = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cancel_btn);
  gtk_object_set_data_full (GTK_OBJECT (gsearch_wnd), "cancel_btn", cancel_btn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_btn);
  gtk_box_pack_start (GTK_BOX (opt_hbox), cancel_btn, FALSE, TRUE, 0);

  /* Хåؿ³ */
  gtk_signal_connect (GTK_OBJECT (ok_btn), "clicked",
                      GTK_SIGNAL_FUNC (gsearch_ok_cb),
                      (gpointer)gsearch_wnd);
  gtk_signal_connect (GTK_OBJECT (cancel_btn), "clicked",
                      GTK_SIGNAL_FUNC (gsearch_cancel_cb),
                      (gpointer)gsearch_wnd);

  /* ܥܥå˥ǡɤ߹ */
  init_combo_list();
  cm_dir.glist = g_list_first(cm_dir.glist);
  if (cm_dir.glist != NULL) {
    if ((cm_dir.glist)->data != NULL) {
      gtk_combo_set_popdown_strings(GTK_COMBO(cm_dir.combo), cm_dir.glist);
    }
  }
  cm_ftype.glist = g_list_first(cm_ftype.glist);
  if (cm_ftype.glist != NULL) {
    if ((cm_ftype.glist)->data != NULL) {
      gtk_combo_set_popdown_strings(GTK_COMBO(cm_ftype.combo), cm_ftype.glist);
    }
  }
  cm_pat.glist = g_list_first(cm_pat.glist);
  if (cm_pat.glist != NULL) {
    if ((cm_pat.glist)->data != NULL) {
      gtk_combo_set_popdown_strings(GTK_COMBO(cm_pat.combo), cm_pat.glist);
    }
  }

  return gsearch_wnd;
}
