/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * ״Ϣδؿ
 */

/*
 * Cmemo : Text Editor
 * jump.c - source file for various jump
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "linenum.h"
#include "document.h"
#include "search.h"
#include "cme_misc.h"
#include "jump.h"

static int jump_visi_flag = 0; /* 0:ɽ 1:ɽ */

/**********************
   ԥץ˥塼
 **********************/
void jump_visi_cb(GtkWidget *widget, gpointer data)
{
  if (jump_visi_flag == 0) {
    gtk_widget_show(cm_jump.button);
    gtk_widget_show(cm_jump.entry);
    gtk_widget_grab_focus(cm_jump.entry);
    jump_visi_flag = 1;
  }
  else {
    gtk_widget_hide(cm_jump.button);
    gtk_widget_hide(cm_jump.entry);
    gtk_widget_grab_focus(current_document->textbox);
    jump_visi_flag = 0;
  }
}

/****************
   
 ****************/
void tag_jump_cb(GtkWidget *widget, gpointer data)
{
  int pos;
  int line;
  int i;
  char *buf;
  int jump_line_no;          /* ֹ */
  int jump_line_col_byte;     /* ֹ(Х) */
  int jump_line_col;         /* ֹ(ʸ) */
  char jump_file_name[1024]; /* פե̾ */
  char *jump_file_name_start;
  char *jump_file_name_end;
  char *comma_pos;
  unsigned char *chr_pos;
  char command[2048];

  line = 0;
  buf = NULL;
  jump_line_no = 0;
  jump_line_col = 0;

  pos = gtk_editable_get_position(GTK_EDITABLE(current_document->textbox));

  for (i = 0; i < MAX_LINE_COUNT - 1; i++) {
    if ((pos > cm_line_count[i]) && (pos <= cm_line_count[i + 1])) {
      line = i + 1;
      break;
    }
  }

  buf = NULL;
  if ((line != 0) && (line <= MAX_LINE_COUNT)) {
    /* debug */
    /*g_print("-----------------------------\n");
    g_print("line:%d\n",line);
    g_print("cm_line_count[line]:%d\n",cm_line_count[line]);
    g_print("cm_line_count[line - 1]:%d\n",cm_line_count[line-1]);*/
    /* ΤԤ1ʬ */
    buf = gtk_editable_get_chars(GTK_EDITABLE(current_document->textbox),
                                 cm_line_count[line - 1] + 1,
                                 cm_line_count[line]);

    /* Ǥֹȷֹ */
    if (buf != NULL) {
      /* debug */
      /*g_print("%d:", line);
      g_print("%s\n", buf);*/
      /* ֹ */
      jump_line_no = atoi(buf);
      comma_pos = strchr(buf, ',');
      if (comma_pos != NULL) {
        /* ֹ */
        jump_line_col_byte = atoi(comma_pos + 1);
        if ((chr_pos = strchr(comma_pos, ':')) != NULL) {
          chr_pos++;
          /* ʸ򥫥Ȥ */
          jump_line_col = get_char_count(chr_pos, jump_line_col_byte, NULL, NULL);
        }
      }
      /* debug */
      /*g_print("jline:%d\n", jump_line_no);
      g_print("jcol:%d\n", jump_line_col);*/
      free(buf);
    }
    else {
      return;
    }
  }
  else {
    return;
  }

  /* 0ܤ˥פϤꤨʤ */
  if (jump_line_no == 0) {
    return;
  }

  buf = NULL;
  /* ޤɤȤϸʤ... */
  for (i = line; i > 0; i--) {
    buf = gtk_editable_get_chars(GTK_EDITABLE(current_document->textbox),
                                 cm_line_count[i - 1] + 1,
                                 cm_line_count[i]);

    if (buf != NULL) {
      /* debug */
      /*g_print("%d : ", i);
      g_print("%s\n", buf);*/
      if (strncmp(buf, "-------", strlen("-------")) == 0) {
        if ((jump_file_name_start = strstr(buf, "- ")) != NULL) {
          jump_file_name_start = jump_file_name_start + 2;
          if ((jump_file_name_end = strstr(jump_file_name_start, " -")) != NULL) {
            memset(&jump_file_name[0], 0, sizeof(jump_file_name));
            memcpy(&jump_file_name[0],
                   jump_file_name_start,
                   jump_file_name_end - jump_file_name_start);
            free(buf);
            break;
          }
        }
      }
      free(buf);
    }
  }

  /* ե̾ǤƤʤ */
  if ((int)jump_file_name[0] == 0) {
    return;
  }
  else {
    /* debug */
    /*g_print("jumpfilename:%s\n", &jump_file_name[0]);*/
    sprintf(&command[0],
            "cmemo -G%d,%d %s &",
            jump_line_no,
            jump_line_col,
            &jump_file_name[0]);
    /* debug */
    /*g_print("command : %s\n", &command[0]);*/
    system(&command[0]);
  }
  return;
}

/************************
   ԥץܥ󲡲
 ************************/
void line_jump_cb(GtkWidget *widget, gpointer data)
{
  char *jump_word;


  gtk_widget_grab_focus(current_document->textbox);

  jump_word = gtk_entry_get_text(GTK_ENTRY(cm_jump.entry));
  if ((jump_word == NULL) || ((int)*jump_word == (int)'\0')) {
    mlwrite("Input Number to Jump!!", 0);
    return;
  }

  line_jump(jump_word);

  /* ؿgtk_entry_get_textentry widgetݻƤʸ */
  /* Υݥ󥿤ϤΤǡfree()ǳưʤ */
  /*free(jump_word);*/
  jump_visi_cb(widget, data);

  /* ԥϥȥ꡼򥯥ꥢ */
  gtk_entry_set_text(GTK_ENTRY(cm_jump.entry), "");

  return;
}

/**************
   ԥ
 **************/
void line_jump(char *jump_word)
{
  gint jump_line_num;
  gint jump_pos;
  gint linenum;
  gchar entry_buf[256];
  gchar tmp_jump_buf[256];
  gchar *comma_pos;
  gint jump_col;


  jump_line_num = atoi(jump_word);
  jump_col = 0;
  if ((comma_pos = strchr(jump_word, ',')) != NULL) {
    jump_col = atoi(comma_pos + 1);
  }

/* debug */
/*g_print("jump_word     : %s\n", jump_word);*/
/*g_print("jump_line_num : %d\n", jump_line_num);*/
  if ((jump_line_num <= 0) ||
      (jump_line_num >= MAX_LINE_COUNT) ||
      (jump_line_num > cm_all_lines)) {
    /* "Can\'t Jump to %s!!" */
    if ((strlen(jump_word) + strlen(CME_CANT_JUMP)) < sizeof(entry_buf)) {
      sprintf(&entry_buf[0], CME_CANT_JUMP, jump_word);
    }
    else {
      memset(&tmp_jump_buf[0], 0, sizeof(tmp_jump_buf));
      memcpy(&tmp_jump_buf[0], jump_word, sizeof(entry_buf) - strlen(CME_CANT_JUMP) - 1);
      sprintf(&entry_buf[0], CME_CANT_JUMP, &tmp_jump_buf[0]);
    }
    mlwrite(&entry_buf[0], 0);
    /* debug */
    /*g_print("cm_all_lines(1) : %d\n", cm_all_lines);*/
    return;
  }

  if (jump_line_num == 1) {
    jump_pos = cm_line_count[jump_line_num - 1] + jump_col;
  }
  else {
    jump_pos = cm_line_count[jump_line_num - 1] + 1 + jump_col;
  }

  if (jump_pos > gtk_text_get_length(GTK_TEXT(current_document->textbox))) {
    if ((strlen(jump_word) + strlen(CME_CANT_JUMP)) < sizeof(entry_buf)) {
      sprintf(&entry_buf[0], CME_CANT_JUMP, jump_word);
    }
    else {
      memset(&tmp_jump_buf[0], 0, sizeof(tmp_jump_buf));
      memcpy(&tmp_jump_buf[0], jump_word, sizeof(entry_buf) - strlen(CME_CANT_JUMP) - 1);
      sprintf(&entry_buf[0], CME_CANT_JUMP, &tmp_jump_buf[0]);
    }
    mlwrite(&entry_buf[0], 0);
    /* debug */
    /*g_print("cm_all_lines(2) : %d\n", cm_all_lines);*/
    return;
  }

  /*ࡼʥ¸٤ jump_line_num  10 ­ͤ linenum */
  if (cm_all_lines > (jump_line_num + 10)) {
    linenum = jump_line_num + 10;
  }
  else {
    linenum = cm_all_lines;
  }
  scrollbar_update(GTK_TEXT(current_document->textbox), cm_all_lines, linenum);

  /*  */
  gtk_text_set_point(GTK_TEXT(current_document->textbox), jump_pos);
  gtk_editable_set_position(GTK_EDITABLE(current_document->textbox), jump_pos);

  /* ɽ */
  sprintf(&entry_buf[0], "Jumped : %s", jump_word);
  mlwrite(&entry_buf[0], 0);

  return;
}
